import { type WebpackLayerName } from '../lib/constants';
import type { NextConfigComplete } from '../server/config-shared';
export declare function createWebpackAliases({ dev, pageExtensions, isEdgeServer, config, pagesDir, appDir, dir, distDir, isClient, reactProductionProfiling, isNodeServer, clientResolveRewrites, hasRewrites, }: {
    dev: boolean;
    pageExtensions: string[];
    isEdgeServer: boolean;
    config: NextConfigComplete;
    pagesDir: string | undefined;
    appDir: string | undefined;
    dir: string;
    distDir: string;
    isClient: boolean;
    reactProductionProfiling: boolean;
    isNodeServer: boolean;
    clientResolveRewrites: string;
    hasRewrites: boolean;
}): {
    alias: string | false | string[];
    name: string;
    onlyModule?: boolean | undefined;
}[] | {
    [index: string]: string | false | string[];
} | undefined;
export declare function createServerOnlyClientOnlyAliases(isServer: boolean): {
    [aliasPath: string]: string;
};
export declare function createRSCAliases(bundledReactChannel: string, opts: {
    layer: WebpackLayerName;
    isEdgeServer: boolean;
    reactProductionProfiling: boolean;
    reactServerCondition?: boolean;
}): Record<string, string>;
export declare function getOptimizedModuleAliases(): {
    [pkg: string]: string;
};
export declare function createServerComponentsNoopAliases(): {
    [x: string]: string;
};
