/**
 * @license React
 * react-dom-server-legacy.node.production.min.js
 *
 * Copyright (c) Meta Platforms, Inc. and affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */
/*


 JS Implementation of MurmurHash3 (r136) (as of May 20, 2011)

 Copyright (c) 2011 Gary Court
 Permission is hereby granted, free of charge, to any person obtaining a copy
 of this software and associated documentation files (the "Software"), to deal
 in the Software without restriction, including without limitation the rights
 to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 copies of the Software, and to permit persons to whom the Software is
 furnished to do so, subject to the following conditions:

 The above copyright notice and this permission notice shall be included in
 all copies or substantial portions of the Software.

 THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 SOFTWARE.
*/
'use strict';var ca=require("next/dist/compiled/react-experimental"),ia=require("react-dom"),ja=require("stream");
function ka(a,b){var c=a.length&3;var d=a.length-c;var e=b;for(b=0;b<d;){var f=a.charCodeAt(b)&255|(a.charCodeAt(++b)&255)<<8|(a.charCodeAt(++b)&255)<<16|(a.charCodeAt(++b)&255)<<24;++b;f=3432918353*(f&65535)+((3432918353*(f>>>16)&65535)<<16)&4294967295;f=f<<15|f>>>17;f=461845907*(f&65535)+((461845907*(f>>>16)&65535)<<16)&4294967295;e^=f;e=e<<13|e>>>19;e=5*(e&65535)+((5*(e>>>16)&65535)<<16)&4294967295;e=(e&65535)+27492+(((e>>>16)+58964&65535)<<16)}f=0;switch(c){case 3:f^=(a.charCodeAt(b+2)&255)<<
16;case 2:f^=(a.charCodeAt(b+1)&255)<<8;case 1:f^=a.charCodeAt(b)&255,f=3432918353*(f&65535)+((3432918353*(f>>>16)&65535)<<16)&4294967295,f=f<<15|f>>>17,e^=461845907*(f&65535)+((461845907*(f>>>16)&65535)<<16)&4294967295}e^=a.length;e^=e>>>16;e=2246822507*(e&65535)+((2246822507*(e>>>16)&65535)<<16)&4294967295;e^=e>>>13;e=3266489909*(e&65535)+((3266489909*(e>>>16)&65535)<<16)&4294967295;return(e^e>>>16)>>>0}
var r=Object.assign,v=Object.prototype.hasOwnProperty,la=RegExp("^[:A-Z_a-z\\u00C0-\\u00D6\\u00D8-\\u00F6\\u00F8-\\u02FF\\u0370-\\u037D\\u037F-\\u1FFF\\u200C-\\u200D\\u2070-\\u218F\\u2C00-\\u2FEF\\u3001-\\uD7FF\\uF900-\\uFDCF\\uFDF0-\\uFFFD][:A-Z_a-z\\u00C0-\\u00D6\\u00D8-\\u00F6\\u00F8-\\u02FF\\u0370-\\u037D\\u037F-\\u1FFF\\u200C-\\u200D\\u2070-\\u218F\\u2C00-\\u2FEF\\u3001-\\uD7FF\\uF900-\\uFDCF\\uFDF0-\\uFFFD\\-.0-9\\u00B7\\u0300-\\u036F\\u203F-\\u2040]*$"),va={},wa={};
function xa(a){if(v.call(wa,a))return!0;if(v.call(va,a))return!1;if(la.test(a))return wa[a]=!0;va[a]=!0;return!1}
var ya=new Set("animationIterationCount aspectRatio borderImageOutset borderImageSlice borderImageWidth boxFlex boxFlexGroup boxOrdinalGroup columnCount columns flex flexGrow flexPositive flexShrink flexNegative flexOrder gridArea gridRow gridRowEnd gridRowSpan gridRowStart gridColumn gridColumnEnd gridColumnSpan gridColumnStart fontWeight lineClamp lineHeight opacity order orphans scale tabSize widows zIndex zoom fillOpacity floodOpacity stopOpacity strokeDasharray strokeDashoffset strokeMiterlimit strokeOpacity strokeWidth MozAnimationIterationCount MozBoxFlex MozBoxFlexGroup MozLineClamp msAnimationIterationCount msFlex msZoom msFlexGrow msFlexNegative msFlexOrder msFlexPositive msFlexShrink msGridColumn msGridColumnSpan msGridRow msGridRowSpan WebkitAnimationIterationCount WebkitBoxFlex WebKitBoxFlexGroup WebkitBoxOrdinalGroup WebkitColumnCount WebkitColumns WebkitFlex WebkitFlexGrow WebkitFlexPositive WebkitFlexShrink WebkitLineClamp".split(" ")),za=
new Map([["acceptCharset","accept-charset"],["htmlFor","for"],["httpEquiv","http-equiv"],["crossOrigin","crossorigin"],["accentHeight","accent-height"],["alignmentBaseline","alignment-baseline"],["arabicForm","arabic-form"],["baselineShift","baseline-shift"],["capHeight","cap-height"],["clipPath","clip-path"],["clipRule","clip-rule"],["colorInterpolation","color-interpolation"],["colorInterpolationFilters","color-interpolation-filters"],["colorProfile","color-profile"],["colorRendering","color-rendering"],
["dominantBaseline","dominant-baseline"],["enableBackground","enable-background"],["fillOpacity","fill-opacity"],["fillRule","fill-rule"],["floodColor","flood-color"],["floodOpacity","flood-opacity"],["fontFamily","font-family"],["fontSize","font-size"],["fontSizeAdjust","font-size-adjust"],["fontStretch","font-stretch"],["fontStyle","font-style"],["fontVariant","font-variant"],["fontWeight","font-weight"],["glyphName","glyph-name"],["glyphOrientationHorizontal","glyph-orientation-horizontal"],["glyphOrientationVertical",
"glyph-orientation-vertical"],["horizAdvX","horiz-adv-x"],["horizOriginX","horiz-origin-x"],["imageRendering","image-rendering"],["letterSpacing","letter-spacing"],["lightingColor","lighting-color"],["markerEnd","marker-end"],["markerMid","marker-mid"],["markerStart","marker-start"],["overlinePosition","overline-position"],["overlineThickness","overline-thickness"],["paintOrder","paint-order"],["panose-1","panose-1"],["pointerEvents","pointer-events"],["renderingIntent","rendering-intent"],["shapeRendering",
"shape-rendering"],["stopColor","stop-color"],["stopOpacity","stop-opacity"],["strikethroughPosition","strikethrough-position"],["strikethroughThickness","strikethrough-thickness"],["strokeDasharray","stroke-dasharray"],["strokeDashoffset","stroke-dashoffset"],["strokeLinecap","stroke-linecap"],["strokeLinejoin","stroke-linejoin"],["strokeMiterlimit","stroke-miterlimit"],["strokeOpacity","stroke-opacity"],["strokeWidth","stroke-width"],["textAnchor","text-anchor"],["textDecoration","text-decoration"],
["textRendering","text-rendering"],["transformOrigin","transform-origin"],["underlinePosition","underline-position"],["underlineThickness","underline-thickness"],["unicodeBidi","unicode-bidi"],["unicodeRange","unicode-range"],["unitsPerEm","units-per-em"],["vAlphabetic","v-alphabetic"],["vHanging","v-hanging"],["vIdeographic","v-ideographic"],["vMathematical","v-mathematical"],["vectorEffect","vector-effect"],["vertAdvY","vert-adv-y"],["vertOriginX","vert-origin-x"],["vertOriginY","vert-origin-y"],
["wordSpacing","word-spacing"],["writingMode","writing-mode"],["xmlnsXlink","xmlns:xlink"],["xHeight","x-height"]]),Aa=/["'&<>]/;
function w(a){if("boolean"===typeof a||"number"===typeof a)return""+a;a=""+a;var b=Aa.exec(a);if(b){var c="",d,e=0;for(d=b.index;d<a.length;d++){switch(a.charCodeAt(d)){case 34:b="&quot;";break;case 38:b="&amp;";break;case 39:b="&#x27;";break;case 60:b="&lt;";break;case 62:b="&gt;";break;default:continue}e!==d&&(c+=a.slice(e,d));e=d+1;c+=b}a=e!==d?c+a.slice(e,d):c}return a}
var Fa=/([A-Z])/g,Ga=/^ms-/,Ha=Array.isArray,Ia=ca.__SECRET_INTERNALS_DO_NOT_USE_OR_YOU_WILL_BE_FIRED,Ja={pending:!1,data:null,method:null,action:null},Ka=ia.__SECRET_INTERNALS_DO_NOT_USE_OR_YOU_WILL_BE_FIRED.Dispatcher,jb={prefetchDNS:La,preconnect:db,preload:eb,preloadModule:fb,preinitStyle:gb,preinitScript:hb,preinitModuleScript:ib},kb=[];
function lb(a,b){var c=0;void 0!==b&&(c=1);return{idPrefix:void 0===a?"":a,nextFormID:0,streamingFormat:c,instructions:0,hasBody:!1,hasHtml:!1,unknownResources:{},dnsResources:{},connectResources:{default:{},anonymous:{},credentials:{}},imageResources:{},styleResources:{},scriptResources:{},moduleUnknownResources:{},moduleScriptResources:{}}}function x(a,b,c){return{insertionMode:a,selectedValue:b,tagScope:c}}
function mb(a){return x("http://www.w3.org/2000/svg"===a?3:"http://www.w3.org/1998/Math/MathML"===a?4:0,null,0)}
function nb(a,b,c){switch(b){case "noscript":return x(2,null,a.tagScope|1);case "select":return x(2,null!=c.value?c.value:c.defaultValue,a.tagScope);case "svg":return x(3,null,a.tagScope);case "picture":return x(2,null,a.tagScope|2);case "math":return x(4,null,a.tagScope);case "foreignObject":return x(2,null,a.tagScope);case "table":return x(5,null,a.tagScope);case "thead":case "tbody":case "tfoot":return x(6,null,a.tagScope);case "colgroup":return x(8,null,a.tagScope);case "tr":return x(7,null,a.tagScope)}return 5<=
a.insertionMode?x(2,null,a.tagScope):0===a.insertionMode?"html"===b?x(1,null,a.tagScope):x(2,null,a.tagScope):1===a.insertionMode?x(2,null,a.tagScope):a}var xb=new Map;
function yb(a,b){if("object"!==typeof b)throw Error("The `style` prop expects a mapping from style properties to values, not a string. For example, style={{marginRight: spacing + 'em'}} when using JSX.");var c=!0,d;for(d in b)if(v.call(b,d)){var e=b[d];if(null!=e&&"boolean"!==typeof e&&""!==e){if(0===d.indexOf("--")){var f=w(d);e=w((""+e).trim())}else f=xb.get(d),void 0===f&&(f=w(d.replace(Fa,"-$1").toLowerCase().replace(Ga,"-ms-")),xb.set(d,f)),e="number"===typeof e?0===e||ya.has(d)?""+e:e+"px":
w((""+e).trim());c?(c=!1,a.push(' style="',f,":",e)):a.push(";",f,":",e)}}c||a.push('"')}function zb(a,b,c){c&&"function"!==typeof c&&"symbol"!==typeof c&&a.push(" ",b,'=""')}function C(a,b,c){"function"!==typeof c&&"symbol"!==typeof c&&"boolean"!==typeof c&&a.push(" ",b,'="',w(c),'"')}function Ab(a){var b=a.nextFormID++;return a.idPrefix+b}var Bb=w("javascript:throw new Error('A React form was unexpectedly submitted.')");
function Cb(a,b){this.push('<input type="hidden"');if("string"!==typeof a)throw Error("File/Blob fields are not yet supported in progressive forms. It probably means you are closing over binary data or FormData in a Server Action.");C(this,"name",b);C(this,"value",a);this.push("/>")}
function Db(a,b,c,d,e,f,g,h){var k=null;"function"===typeof d&&("function"===typeof d.$$FORM_ACTION?(e=Ab(b),b=d.$$FORM_ACTION(e),h=b.name,d=b.action||"",e=b.encType,f=b.method,g=b.target,k=b.data):(a.push(" ","formAction",'="',Bb,'"'),g=f=e=d=h=null,Eb(b,c)));null!=h&&D(a,"name",h);null!=d&&D(a,"formAction",d);null!=e&&D(a,"formEncType",e);null!=f&&D(a,"formMethod",f);null!=g&&D(a,"formTarget",g);return k}
function D(a,b,c){switch(b){case "className":C(a,"class",c);break;case "tabIndex":C(a,"tabindex",c);break;case "dir":case "role":case "viewBox":case "width":case "height":C(a,b,c);break;case "style":yb(a,c);break;case "src":case "href":if(""===c)break;case "action":case "formAction":if(null==c||"function"===typeof c||"symbol"===typeof c||"boolean"===typeof c)break;a.push(" ",b,'="',w(""+c),'"');break;case "defaultValue":case "defaultChecked":case "innerHTML":case "suppressContentEditableWarning":case "suppressHydrationWarning":break;
case "autoFocus":case "multiple":case "muted":zb(a,b.toLowerCase(),c);break;case "xlinkHref":if("function"===typeof c||"symbol"===typeof c||"boolean"===typeof c)break;a.push(" ","xlink:href",'="',w(""+c),'"');break;case "contentEditable":case "spellCheck":case "draggable":case "value":case "autoReverse":case "externalResourcesRequired":case "focusable":case "preserveAlpha":"function"!==typeof c&&"symbol"!==typeof c&&a.push(" ",b,'="',w(c),'"');break;case "allowFullScreen":case "async":case "autoPlay":case "controls":case "default":case "defer":case "disabled":case "disablePictureInPicture":case "disableRemotePlayback":case "formNoValidate":case "hidden":case "loop":case "noModule":case "noValidate":case "open":case "playsInline":case "readOnly":case "required":case "reversed":case "scoped":case "seamless":case "itemScope":c&&
"function"!==typeof c&&"symbol"!==typeof c&&a.push(" ",b,'=""');break;case "capture":case "download":!0===c?a.push(" ",b,'=""'):!1!==c&&"function"!==typeof c&&"symbol"!==typeof c&&a.push(" ",b,'="',w(c),'"');break;case "cols":case "rows":case "size":case "span":"function"!==typeof c&&"symbol"!==typeof c&&!isNaN(c)&&1<=c&&a.push(" ",b,'="',w(c),'"');break;case "rowSpan":case "start":"function"===typeof c||"symbol"===typeof c||isNaN(c)||a.push(" ",b,'="',w(c),'"');break;case "xlinkActuate":C(a,"xlink:actuate",
c);break;case "xlinkArcrole":C(a,"xlink:arcrole",c);break;case "xlinkRole":C(a,"xlink:role",c);break;case "xlinkShow":C(a,"xlink:show",c);break;case "xlinkTitle":C(a,"xlink:title",c);break;case "xlinkType":C(a,"xlink:type",c);break;case "xmlBase":C(a,"xml:base",c);break;case "xmlLang":C(a,"xml:lang",c);break;case "xmlSpace":C(a,"xml:space",c);break;default:if(!(2<b.length)||"o"!==b[0]&&"O"!==b[0]||"n"!==b[1]&&"N"!==b[1])if(b=za.get(b)||b,xa(b)){switch(typeof c){case "function":case "symbol":return;
case "boolean":var d=b.toLowerCase().slice(0,5);if("data-"!==d&&"aria-"!==d)return}a.push(" ",b,'="',w(c),'"')}}}function E(a,b,c){if(null!=b){if(null!=c)throw Error("Can only set one of `children` or `props.dangerouslySetInnerHTML`.");if("object"!==typeof b||!("__html"in b))throw Error("`props.dangerouslySetInnerHTML` must be in the form `{__html: ...}`. Please visit https://reactjs.org/link/dangerously-set-inner-html for more information.");b=b.__html;null!==b&&void 0!==b&&a.push(""+b)}}
function Fb(a){var b="";ca.Children.forEach(a,function(c){null!=c&&(b+=c)});return b}
function Eb(a,b){0!==(a.instructions&16)||b.externalRuntimeScript||(a.instructions|=16,b.bootstrapChunks.unshift(b.startInlineScript,'addEventListener("submit",function(a){if(!a.defaultPrevented){var c=a.target,d=a.submitter,e=c.action,b=d;if(d){var f=d.getAttribute("formAction");null!=f&&(e=f,b=null)}"javascript:throw new Error(\'A React form was unexpectedly submitted.\')"===e&&(a.preventDefault(),b?(a=document.createElement("input"),a.name=b.name,a.value=b.value,b.parentNode.insertBefore(a,b),b=new FormData(c),a.parentNode.removeChild(a)):b=new FormData(c),a=c.getRootNode(),(a.$$reactFormReplay=a.$$reactFormReplay||[]).push(c,\nd,b))}});',"\x3c/script>"))}
function Gb(a,b,c,d,e,f,g){var h=b.rel,k=b.href,l=b.precedence;if(3===f||g||null!=b.itemProp||"string"!==typeof h||"string"!==typeof k||""===k)return H(a,b),null;if("stylesheet"===b.rel){if("string"!==typeof l||null!=b.disabled||b.onLoad||b.onError)return H(a,b);f=d.styles.get(l);g=c.styleResources.hasOwnProperty(k)?c.styleResources[k]:void 0;null!==g?(c.styleResources[k]=null,f||(f={precedence:w(l),rules:[],hrefs:[],sheets:new Map},d.styles.set(l,f)),b={state:0,props:r({},b,{"data-precedence":b.precedence,
precedence:null})},g&&(2===g.length&&Hb(b.props,g),(c=d.preloads.stylesheets.get(k))&&0<c.length?c.length=0:b.state=1),f.sheets.set(k,b),d.boundaryResources&&d.boundaryResources.stylesheets.add(b)):f&&(k=f.sheets.get(k))&&d.boundaryResources&&d.boundaryResources.stylesheets.add(k);e&&a.push("\x3c!-- --\x3e");return null}if(b.onLoad||b.onError)return H(a,b);e&&a.push("\x3c!-- --\x3e");switch(b.rel){case "preconnect":case "dns-prefetch":return H(d.preconnectChunks,b);case "preload":return H(d.preloadChunks,
b);default:return H(d.hoistableChunks,b)}}function H(a,b){a.push(I("link"));for(var c in b)if(v.call(b,c)){var d=b[c];if(null!=d)switch(c){case "children":case "dangerouslySetInnerHTML":throw Error("link is a self-closing tag and must neither have `children` nor use `dangerouslySetInnerHTML`.");default:D(a,c,d)}}a.push("/>");return null}
function Ib(a,b,c){a.push(I(c));for(var d in b)if(v.call(b,d)){var e=b[d];if(null!=e)switch(d){case "children":case "dangerouslySetInnerHTML":throw Error(c+" is a self-closing tag and must neither have `children` nor use `dangerouslySetInnerHTML`.");default:D(a,d,e)}}a.push("/>");return null}
function Jb(a,b){a.push(I("title"));var c=null,d=null,e;for(e in b)if(v.call(b,e)){var f=b[e];if(null!=f)switch(e){case "children":c=f;break;case "dangerouslySetInnerHTML":d=f;break;default:D(a,e,f)}}a.push(">");b=Array.isArray(c)?2>c.length?c[0]:null:c;"function"!==typeof b&&"symbol"!==typeof b&&null!==b&&void 0!==b&&a.push(w(""+b));E(a,d,c);a.push("</","title",">");return null}
function Kb(a,b){a.push(I("script"));var c=null,d=null,e;for(e in b)if(v.call(b,e)){var f=b[e];if(null!=f)switch(e){case "children":c=f;break;case "dangerouslySetInnerHTML":d=f;break;default:D(a,e,f)}}a.push(">");E(a,d,c);"string"===typeof c&&a.push(w(c));a.push("</","script",">");return null}
function Lb(a,b,c){a.push(I(c));var d=c=null,e;for(e in b)if(v.call(b,e)){var f=b[e];if(null!=f)switch(e){case "children":c=f;break;case "dangerouslySetInnerHTML":d=f;break;default:D(a,e,f)}}a.push(">");E(a,d,c);return"string"===typeof c?(a.push(w(c)),null):c}var Mb=/^[a-zA-Z][a-zA-Z:_\.\-\d]*$/,Nb=new Map;function I(a){var b=Nb.get(a);if(void 0===b){if(!Mb.test(a))throw Error("Invalid tag: "+a);b="<"+a;Nb.set(a,b)}return b}
function Ob(a,b,c,d,e,f,g){switch(b){case "div":case "span":case "svg":case "path":case "a":case "g":case "p":case "li":break;case "select":a.push(I("select"));var h=null,k=null,l;for(l in c)if(v.call(c,l)){var n=c[l];if(null!=n)switch(l){case "children":h=n;break;case "dangerouslySetInnerHTML":k=n;break;case "defaultValue":case "value":break;default:D(a,l,n)}}a.push(">");E(a,k,h);return h;case "option":var q=f.selectedValue;a.push(I("option"));var m=null,y=null,A=null,Q=null,M;for(M in c)if(v.call(c,
M)){var p=c[M];if(null!=p)switch(M){case "children":m=p;break;case "selected":A=p;break;case "dangerouslySetInnerHTML":Q=p;break;case "value":y=p;default:D(a,M,p)}}if(null!=q){var t=null!==y?""+y:Fb(m);if(Ha(q))for(var Z=0;Z<q.length;Z++){if(""+q[Z]===t){a.push(' selected=""');break}}else""+q===t&&a.push(' selected=""')}else A&&a.push(' selected=""');a.push(">");E(a,Q,m);return m;case "textarea":a.push(I("textarea"));var F=null,N=null,u=null,z;for(z in c)if(v.call(c,z)){var U=c[z];if(null!=U)switch(z){case "children":u=
U;break;case "value":F=U;break;case "defaultValue":N=U;break;case "dangerouslySetInnerHTML":throw Error("`dangerouslySetInnerHTML` does not make sense on <textarea>.");default:D(a,z,U)}}null===F&&null!==N&&(F=N);a.push(">");if(null!=u){if(null!=F)throw Error("If you supply `defaultValue` on a <textarea>, do not pass children.");if(Ha(u)){if(1<u.length)throw Error("<textarea> can only have at most one child.");F=""+u[0]}F=""+u}"string"===typeof F&&"\n"===F[0]&&a.push("\n");null!==F&&a.push(w(""+F));
return null;case "input":a.push(I("input"));var P=null,da=null,G=null,ea=null,aa=null,Ma=null,Na=null,Oa=null,Pa=null,ma;for(ma in c)if(v.call(c,ma)){var O=c[ma];if(null!=O)switch(ma){case "children":case "dangerouslySetInnerHTML":throw Error("input is a self-closing tag and must neither have `children` nor use `dangerouslySetInnerHTML`.");case "name":P=O;break;case "formAction":da=O;break;case "formEncType":G=O;break;case "formMethod":ea=O;break;case "formTarget":aa=O;break;case "defaultChecked":Pa=
O;break;case "defaultValue":Na=O;break;case "checked":Oa=O;break;case "value":Ma=O;break;default:D(a,ma,O)}}var ob=Db(a,d,e,da,G,ea,aa,P);null!==Oa?zb(a,"checked",Oa):null!==Pa&&zb(a,"checked",Pa);null!==Ma?D(a,"value",Ma):null!==Na&&D(a,"value",Na);a.push("/>");null!==ob&&ob.forEach(Cb,a);return null;case "button":a.push(I("button"));var V=null,na=null,oa=null,pa=null,Qa=null,qa=null,Gc=null,Ra;for(Ra in c)if(v.call(c,Ra)){var ba=c[Ra];if(null!=ba)switch(Ra){case "children":V=ba;break;case "dangerouslySetInnerHTML":na=
ba;break;case "name":oa=ba;break;case "formAction":pa=ba;break;case "formEncType":Qa=ba;break;case "formMethod":qa=ba;break;case "formTarget":Gc=ba;break;default:D(a,Ra,ba)}}var Hc=Db(a,d,e,pa,Qa,qa,Gc,oa);a.push(">");null!==Hc&&Hc.forEach(Cb,a);E(a,na,V);if("string"===typeof V){a.push(w(V));var Ic=null}else Ic=V;return Ic;case "form":a.push(I("form"));var Sa=null,Jc=null,fa=null,Ta=null,Ua=null,Va=null,Wa;for(Wa in c)if(v.call(c,Wa)){var ha=c[Wa];if(null!=ha)switch(Wa){case "children":Sa=ha;break;
case "dangerouslySetInnerHTML":Jc=ha;break;case "action":fa=ha;break;case "encType":Ta=ha;break;case "method":Ua=ha;break;case "target":Va=ha;break;default:D(a,Wa,ha)}}var Tb=null,Ub=null;if("function"===typeof fa)if("function"===typeof fa.$$FORM_ACTION){var ne=Ab(d),Ba=fa.$$FORM_ACTION(ne);fa=Ba.action||"";Ta=Ba.encType;Ua=Ba.method;Va=Ba.target;Tb=Ba.data;Ub=Ba.name}else a.push(" ","action",'="',Bb,'"'),Va=Ua=Ta=fa=null,Eb(d,e);null!=fa&&D(a,"action",fa);null!=Ta&&D(a,"encType",Ta);null!=Ua&&D(a,
"method",Ua);null!=Va&&D(a,"target",Va);a.push(">");null!==Ub&&(a.push('<input type="hidden"'),C(a,"name",Ub),a.push("/>"),null!==Tb&&Tb.forEach(Cb,a));E(a,Jc,Sa);if("string"===typeof Sa){a.push(w(Sa));var Kc=null}else Kc=Sa;return Kc;case "menuitem":a.push(I("menuitem"));for(var pb in c)if(v.call(c,pb)){var Lc=c[pb];if(null!=Lc)switch(pb){case "children":case "dangerouslySetInnerHTML":throw Error("menuitems cannot have `children` nor `dangerouslySetInnerHTML`.");default:D(a,pb,Lc)}}a.push(">");return null;
case "title":if(3===f.insertionMode||f.tagScope&1||null!=c.itemProp)var Mc=Jb(a,c);else Jb(e.hoistableChunks,c),Mc=null;return Mc;case "link":return Gb(a,c,d,e,g,f.insertionMode,!!(f.tagScope&1));case "script":var Vb=c.async;if("string"!==typeof c.src||!c.src||!Vb||"function"===typeof Vb||"symbol"===typeof Vb||c.onLoad||c.onError||3===f.insertionMode||f.tagScope&1||null!=c.itemProp)var Nc=Kb(a,c);else{var qb=c.src;if("module"===c.type){var rb=d.moduleScriptResources;var Oc=e.preloads.moduleScripts}else rb=
d.scriptResources,Oc=e.preloads.scripts;var sb=rb.hasOwnProperty(qb)?rb[qb]:void 0;if(null!==sb){rb[qb]=null;var Wb=c;if(sb){2===sb.length&&(Wb=r({},c),Hb(Wb,sb));var Pc=Oc.get(qb);Pc&&(Pc.length=0)}var Qc=[];e.scripts.add(Qc);Kb(Qc,Wb)}g&&a.push("\x3c!-- --\x3e");Nc=null}return Nc;case "style":var tb=c.precedence,ra=c.href;if(3===f.insertionMode||f.tagScope&1||null!=c.itemProp||"string"!==typeof tb||"string"!==typeof ra||""===ra){a.push(I("style"));var Ca=null,Rc=null,Xa;for(Xa in c)if(v.call(c,
Xa)){var ub=c[Xa];if(null!=ub)switch(Xa){case "children":Ca=ub;break;case "dangerouslySetInnerHTML":Rc=ub;break;default:D(a,Xa,ub)}}a.push(">");var Ya=Array.isArray(Ca)?2>Ca.length?Ca[0]:null:Ca;"function"!==typeof Ya&&"symbol"!==typeof Ya&&null!==Ya&&void 0!==Ya&&a.push(w(""+Ya));E(a,Rc,Ca);a.push("</","style",">");var Sc=null}else{var sa=e.styles.get(tb);if(null!==(d.styleResources.hasOwnProperty(ra)?d.styleResources[ra]:void 0)){d.styleResources[ra]=null;sa?sa.hrefs.push(w(ra)):(sa={precedence:w(tb),
rules:[],hrefs:[w(ra)],sheets:new Map},e.styles.set(tb,sa));var Tc=sa.rules,Da=null,Uc=null,vb;for(vb in c)if(v.call(c,vb)){var Xb=c[vb];if(null!=Xb)switch(vb){case "children":Da=Xb;break;case "dangerouslySetInnerHTML":Uc=Xb}}var Za=Array.isArray(Da)?2>Da.length?Da[0]:null:Da;"function"!==typeof Za&&"symbol"!==typeof Za&&null!==Za&&void 0!==Za&&Tc.push(w(""+Za));E(Tc,Uc,Da)}sa&&e.boundaryResources&&e.boundaryResources.styles.add(sa);g&&a.push("\x3c!-- --\x3e");Sc=void 0}return Sc;case "meta":if(3===
f.insertionMode||f.tagScope&1||null!=c.itemProp)var Vc=Ib(a,c,"meta");else g&&a.push("\x3c!-- --\x3e"),Vc="string"===typeof c.charSet?Ib(e.charsetChunks,c,"meta"):"viewport"===c.name?Ib(e.preconnectChunks,c,"meta"):Ib(e.hoistableChunks,c,"meta");return Vc;case "listing":case "pre":a.push(I(b));var $a=null,ab=null,bb;for(bb in c)if(v.call(c,bb)){var wb=c[bb];if(null!=wb)switch(bb){case "children":$a=wb;break;case "dangerouslySetInnerHTML":ab=wb;break;default:D(a,bb,wb)}}a.push(">");if(null!=ab){if(null!=
$a)throw Error("Can only set one of `children` or `props.dangerouslySetInnerHTML`.");if("object"!==typeof ab||!("__html"in ab))throw Error("`props.dangerouslySetInnerHTML` must be in the form `{__html: ...}`. Please visit https://reactjs.org/link/dangerously-set-inner-html for more information.");var ta=ab.__html;null!==ta&&void 0!==ta&&("string"===typeof ta&&0<ta.length&&"\n"===ta[0]?a.push("\n",ta):a.push(""+ta))}"string"===typeof $a&&"\n"===$a[0]&&a.push("\n");return $a;case "img":var K=c.src,
B=c.srcSet;if(!("lazy"===c.loading||!K&&!B||"string"!==typeof K&&null!=K||"string"!==typeof B&&null!=B)&&"low"!==c.fetchPriority&&!1===!!(f.tagScope&2)&&("string"!==typeof K||":"!==K[4]||"d"!==K[0]&&"D"!==K[0]||"a"!==K[1]&&"A"!==K[1]||"t"!==K[2]&&"T"!==K[2]||"a"!==K[3]&&"A"!==K[3])&&("string"!==typeof B||":"!==B[4]||"d"!==B[0]&&"D"!==B[0]||"a"!==B[1]&&"A"!==B[1]||"t"!==B[2]&&"T"!==B[2]||"a"!==B[3]&&"A"!==B[3])){var Wc="string"===typeof c.sizes?c.sizes:void 0,cb=B?B+"\n"+(Wc||""):K,Yb=e.preloads.images,
ua=Yb.get(cb);if(ua){if("high"===c.fetchPriority||10>e.highImagePreloads.size)Yb.delete(cb),e.highImagePreloads.add(ua)}else d.imageResources.hasOwnProperty(cb)||(d.imageResources[cb]=kb,ua=[],H(ua,{rel:"preload",as:"image",href:B?void 0:K,imageSrcSet:B,imageSizes:Wc,crossOrigin:c.crossOrigin,integrity:c.integrity,type:c.type,fetchPriority:c.fetchPriority,referrerPolicy:c.referrerPolicy}),"high"===c.fetchPriority||10>e.highImagePreloads.size?e.highImagePreloads.add(ua):(e.bulkPreloads.add(ua),Yb.set(cb,
ua)))}return Ib(a,c,"img");case "base":case "area":case "br":case "col":case "embed":case "hr":case "keygen":case "param":case "source":case "track":case "wbr":return Ib(a,c,b);case "annotation-xml":case "color-profile":case "font-face":case "font-face-src":case "font-face-uri":case "font-face-format":case "font-face-name":case "missing-glyph":break;case "head":if(2>f.insertionMode&&null===e.headChunks){e.headChunks=[];var Xc=Lb(e.headChunks,c,"head")}else Xc=Lb(a,c,"head");return Xc;case "html":if(0===
f.insertionMode&&null===e.htmlChunks){e.htmlChunks=[""];var Yc=Lb(e.htmlChunks,c,"html")}else Yc=Lb(a,c,"html");return Yc;default:if(-1!==b.indexOf("-")){a.push(I(b));var Zb=null,Zc=null,Ea;for(Ea in c)if(v.call(c,Ea)){var R=c[Ea];if(null!=R){var $c=Ea;switch(Ea){case "children":Zb=R;break;case "dangerouslySetInnerHTML":Zc=R;break;case "style":yb(a,R);break;case "suppressContentEditableWarning":case "suppressHydrationWarning":break;case "className":$c="class";default:if(xa(Ea)&&"function"!==typeof R&&
"symbol"!==typeof R&&!1!==R){if(!0===R)R="";else if("object"===typeof R)continue;a.push(" ",$c,'="',w(R),'"')}}}}a.push(">");E(a,Zc,Zb);return Zb}}return Lb(a,c,b)}function Pb(a,b){b=b.bootstrapChunks;for(var c=0;c<b.length-1;c++)a.push(b[c]);return c<b.length?(c=b[c],b.length=0,a.push(c)):!0}
function Qb(a,b,c){a.push('\x3c!--$?--\x3e<template id="');if(null===c)throw Error("An ID must have been assigned before we can complete the boundary.");a.push(b.boundaryPrefix);b=c.toString(16);a.push(b);return a.push('"></template>')}
function Rb(a,b,c,d){switch(c.insertionMode){case 0:case 1:case 2:return a.push('<div hidden id="'),a.push(b.segmentPrefix),b=d.toString(16),a.push(b),a.push('">');case 3:return a.push('<svg aria-hidden="true" style="display:none" id="'),a.push(b.segmentPrefix),b=d.toString(16),a.push(b),a.push('">');case 4:return a.push('<math aria-hidden="true" style="display:none" id="'),a.push(b.segmentPrefix),b=d.toString(16),a.push(b),a.push('">');case 5:return a.push('<table hidden id="'),a.push(b.segmentPrefix),
b=d.toString(16),a.push(b),a.push('">');case 6:return a.push('<table hidden><tbody id="'),a.push(b.segmentPrefix),b=d.toString(16),a.push(b),a.push('">');case 7:return a.push('<table hidden><tr id="'),a.push(b.segmentPrefix),b=d.toString(16),a.push(b),a.push('">');case 8:return a.push('<table hidden><colgroup id="'),a.push(b.segmentPrefix),b=d.toString(16),a.push(b),a.push('">');default:throw Error("Unknown insertion mode. This is a bug in React.");}}
function Sb(a,b){switch(b.insertionMode){case 0:case 1:case 2:return a.push("</div>");case 3:return a.push("</svg>");case 4:return a.push("</math>");case 5:return a.push("</table>");case 6:return a.push("</tbody></table>");case 7:return a.push("</tr></table>");case 8:return a.push("</colgroup></table>");default:throw Error("Unknown insertion mode. This is a bug in React.");}}var $b=/[<\u2028\u2029]/g;
function ac(a){return JSON.stringify(a).replace($b,function(b){switch(b){case "<":return"\\u003c";case "\u2028":return"\\u2028";case "\u2029":return"\\u2029";default:throw Error("escapeJSStringsForInstructionScripts encountered a match it does not know how to replace. this means the match regex and the replacement characters are no longer in sync. This is a bug in React");}})}var bc=/[&><\u2028\u2029]/g;
function cc(a){return JSON.stringify(a).replace(bc,function(b){switch(b){case "&":return"\\u0026";case ">":return"\\u003e";case "<":return"\\u003c";case "\u2028":return"\\u2028";case "\u2029":return"\\u2029";default:throw Error("escapeJSObjectForInstructionScripts encountered a match it does not know how to replace. this means the match regex and the replacement characters are no longer in sync. This is a bug in React");}})}var dc=!1,ec=!0;
function fc(a){var b=a.rules,c=a.hrefs,d=0;if(c.length){this.push('<style media="not all" data-precedence="');this.push(a.precedence);for(this.push('" data-href="');d<c.length-1;d++)this.push(c[d]),this.push(" ");this.push(c[d]);this.push('">');for(d=0;d<b.length;d++)this.push(b[d]);ec=this.push("</style>");dc=!0;b.length=0;c.length=0}}function gc(a){return 2!==a.state?dc=!0:!1}function hc(a,b,c){dc=!1;ec=!0;b.styles.forEach(fc,a);b.stylesheets.forEach(gc);dc&&(c.stylesToHoist=!0);return ec}
function J(a){for(var b=0;b<a.length;b++)this.push(a[b]);a.length=0}var ic=[];function jc(a){H(ic,a.props);for(var b=0;b<ic.length;b++)this.push(ic[b]);ic.length=0;a.state=2}
function kc(a){var b=0<a.sheets.size;a.sheets.forEach(jc,this);a.sheets.clear();var c=a.rules,d=a.hrefs;if(!b||d.length){this.push('<style data-precedence="');this.push(a.precedence);a=0;if(d.length){for(this.push('" data-href="');a<d.length-1;a++)this.push(d[a]),this.push(" ");this.push(d[a])}this.push('">');for(a=0;a<c.length;a++)this.push(c[a]);this.push("</style>");c.length=0;d.length=0}}
function lc(a){if(0===a.state){a.state=1;var b=a.props;H(ic,{rel:"preload",as:"style",href:a.props.href,crossOrigin:b.crossOrigin,fetchPriority:b.fetchPriority,integrity:b.integrity,media:b.media,hrefLang:b.hrefLang,referrerPolicy:b.referrerPolicy});for(a=0;a<ic.length;a++)this.push(ic[a]);ic.length=0}}function mc(a){a.sheets.forEach(lc,this);a.sheets.clear()}
function nc(a,b){a.push("[");var c="[";b.stylesheets.forEach(function(d){if(2!==d.state)if(3===d.state)a.push(c),d=cc(""+d.props.href),a.push(d),a.push("]"),c=",[";else{a.push(c);var e=d.props["data-precedence"],f=d.props,g=cc(""+d.props.href);a.push(g);e=""+e;a.push(",");e=cc(e);a.push(e);for(var h in f)if(v.call(f,h)&&(g=f[h],null!=g))switch(h){case "href":case "rel":case "precedence":case "data-precedence":break;case "children":case "dangerouslySetInnerHTML":throw Error("link is a self-closing tag and must neither have `children` nor use `dangerouslySetInnerHTML`.");
default:a:{e=a;var k=h.toLowerCase();switch(typeof g){case "function":case "symbol":break a}switch(h){case "innerHTML":case "dangerouslySetInnerHTML":case "suppressContentEditableWarning":case "suppressHydrationWarning":case "style":break a;case "className":k="class";g=""+g;break;case "hidden":if(!1===g)break a;g="";break;case "src":case "href":g=""+g;break;default:if(2<h.length&&("o"===h[0]||"O"===h[0])&&("n"===h[1]||"N"===h[1])||!xa(h))break a;g=""+g}e.push(",");k=cc(k);e.push(k);e.push(",");g=
cc(g);e.push(g)}}a.push("]");c=",[";d.state=3}});a.push("]")}
function oc(a,b){a.push("[");var c="[";b.stylesheets.forEach(function(d){if(2!==d.state)if(3===d.state)a.push(c),d=w(JSON.stringify(""+d.props.href)),a.push(d),a.push("]"),c=",[";else{a.push(c);var e=d.props["data-precedence"],f=d.props,g=w(JSON.stringify(""+d.props.href));a.push(g);e=""+e;a.push(",");e=w(JSON.stringify(e));a.push(e);for(var h in f)if(v.call(f,h)&&(g=f[h],null!=g))switch(h){case "href":case "rel":case "precedence":case "data-precedence":break;case "children":case "dangerouslySetInnerHTML":throw Error("link is a self-closing tag and must neither have `children` nor use `dangerouslySetInnerHTML`.");
default:a:{e=a;var k=h.toLowerCase();switch(typeof g){case "function":case "symbol":break a}switch(h){case "innerHTML":case "dangerouslySetInnerHTML":case "suppressContentEditableWarning":case "suppressHydrationWarning":case "style":break a;case "className":k="class";g=""+g;break;case "hidden":if(!1===g)break a;g="";break;case "src":case "href":g=""+g;break;default:if(2<h.length&&("o"===h[0]||"O"===h[0])&&("n"===h[1]||"N"===h[1])||!xa(h))break a;g=""+g}e.push(",");k=w(JSON.stringify(k));e.push(k);
e.push(",");g=w(JSON.stringify(g));e.push(g)}}a.push("]");c=",[";d.state=3}});a.push("]")}function La(a){var b=L?L:null;if(b){var c=b.resumableState,d=b.renderState;if("string"===typeof a&&a){if(!c.dnsResources.hasOwnProperty(a)){var e=[];c.dnsResources[a]=null;H(e,{href:a,rel:"dns-prefetch"});d.preconnects.add(e)}pc(b)}}}
function db(a,b){var c=L?L:null;if(c){var d=c.resumableState,e=c.renderState;if("string"===typeof a&&a){d="use-credentials"===b?d.connectResources.credentials:"string"===typeof b?d.connectResources.anonymous:d.connectResources.default;if(!d.hasOwnProperty(a)){var f=[];d[a]=null;H(f,{rel:"preconnect",href:a,crossOrigin:b});e.preconnects.add(f)}pc(c)}}}
function eb(a,b,c){var d=L?L:null;if(d){var e=d.resumableState,f=d.renderState;if(b&&a){switch(b){case "image":if(c){var g=c.imageSrcSet;var h=c.imageSizes;var k=c.fetchPriority}h=g?g+"\n"+(h||""):a;if(e.imageResources.hasOwnProperty(h))return;e.imageResources[h]=kb;e=[];H(e,r({rel:"preload",href:g?void 0:a,as:b},c));"high"===k?f.highImagePreloads.add(e):(f.bulkPreloads.add(e),f.preloads.images.set(h,e));break;case "style":if(e.styleResources.hasOwnProperty(a))return;g=[];H(g,r({rel:"preload",href:a,
as:b},c));e.styleResources[a]=!c||"string"!==typeof c.crossOrigin&&"string"!==typeof c.integrity?kb:[c.crossOrigin,c.integrity];f.preloads.stylesheets.set(a,g);f.bulkPreloads.add(g);break;case "script":if(e.scriptResources.hasOwnProperty(a))return;g=[];f.preloads.scripts.set(a,g);f.bulkPreloads.add(g);H(g,r({rel:"preload",href:a,as:b},c));e.scriptResources[a]=!c||"string"!==typeof c.crossOrigin&&"string"!==typeof c.integrity?kb:[c.crossOrigin,c.integrity];break;default:if(e.unknownResources.hasOwnProperty(b)){if(g=
e.unknownResources[b],g.hasOwnProperty(a))return}else g={},e.unknownResources[b]=g;e=[];c=r({rel:"preload",href:a,as:b},c);switch(b){case "font":f.fontPreloads.add(e);break;default:f.bulkPreloads.add(e)}H(e,c);g[a]=kb}pc(d)}}}
function fb(a,b){var c=L?L:null;if(c){var d=c.resumableState,e=c.renderState;if(a){var f=b&&"string"===typeof b.as?b.as:"script";switch(f){case "script":if(d.moduleScriptResources.hasOwnProperty(a))return;f=[];d.moduleScriptResources[a]=!b||"string"!==typeof b.crossOrigin&&"string"!==typeof b.integrity?kb:[b.crossOrigin,b.integrity];e.preloads.moduleScripts.set(a,f);break;default:if(d.moduleUnknownResources.hasOwnProperty(f)){var g=d.unknownResources[f];if(g.hasOwnProperty(a))return}else g={},d.moduleUnknownResources[f]=
g;f=[];g[a]=kb}H(f,r({rel:"modulepreload",href:a},b));e.bulkPreloads.add(f);pc(c)}}}
function gb(a,b,c){var d=L?L:null;if(d){var e=d.resumableState,f=d.renderState;if(a){b=b||"default";var g=f.styles.get(b),h=e.styleResources.hasOwnProperty(a)?e.styleResources[a]:void 0;null!==h&&(e.styleResources[a]=null,g||(g={precedence:w(b),rules:[],hrefs:[],sheets:new Map},f.styles.set(b,g)),b={state:0,props:r({rel:"stylesheet",href:a,"data-precedence":b},c)},h&&(2===h.length&&Hb(b.props,h),(f=f.preloads.stylesheets.get(a))&&0<f.length?f.length=0:b.state=1),g.sheets.set(a,b),pc(d))}}}
function hb(a,b){var c=L?L:null;if(c){var d=c.resumableState,e=c.renderState;if(a){var f=d.scriptResources.hasOwnProperty(a)?d.scriptResources[a]:void 0;null!==f&&(d.scriptResources[a]=null,b=r({src:a,async:!0},b),f&&(2===f.length&&Hb(b,f),a=e.preloads.scripts.get(a))&&(a.length=0),a=[],e.scripts.add(a),Kb(a,b),pc(c))}}}
function ib(a,b){var c=L?L:null;if(c){var d=c.resumableState,e=c.renderState;if(a){var f=d.moduleScriptResources.hasOwnProperty(a)?d.moduleScriptResources[a]:void 0;null!==f&&(d.moduleScriptResources[a]=null,b=r({src:a,type:"module",async:!0},b),f&&(2===f.length&&Hb(b,f),a=e.preloads.moduleScripts.get(a))&&(a.length=0),a=[],e.scripts.add(a),Kb(a,b),pc(c))}}}function Hb(a,b){null==a.crossOrigin&&(a.crossOrigin=b[0]);null==a.integrity&&(a.integrity=b[1])}function qc(a){this.styles.add(a)}
function rc(a){this.stylesheets.add(a)}
function sc(a,b){var c=a.idPrefix;a=c+"P:";var d=c+"S:";c+="B:";var e=new Set,f=new Set,g=new Set,h=new Map,k=new Set,l=new Set,n=new Set,q={images:new Map,stylesheets:new Map,scripts:new Map,moduleScripts:new Map};return{placeholderPrefix:a,segmentPrefix:d,boundaryPrefix:c,startInlineScript:"<script>",htmlChunks:null,headChunks:null,externalRuntimeScript:null,bootstrapChunks:[],charsetChunks:[],preconnectChunks:[],importMapChunks:[],preloadChunks:[],hoistableChunks:[],preconnects:e,fontPreloads:f,
highImagePreloads:g,styles:h,bootstrapScripts:k,scripts:l,bulkPreloads:n,preloads:q,boundaryResources:null,stylesToHoist:!1,generateStaticMarkup:b}}function tc(a,b,c,d){if(c.generateStaticMarkup)return a.push(w(b)),!1;""===b?a=d:(d&&a.push("\x3c!-- --\x3e"),a.push(w(b)),a=!0);return a}
var uc=Symbol.for("react.element"),vc=Symbol.for("react.portal"),wc=Symbol.for("react.fragment"),xc=Symbol.for("react.strict_mode"),yc=Symbol.for("react.profiler"),zc=Symbol.for("react.provider"),Ac=Symbol.for("react.context"),Bc=Symbol.for("react.server_context"),Cc=Symbol.for("react.forward_ref"),Dc=Symbol.for("react.suspense"),Ec=Symbol.for("react.suspense_list"),Fc=Symbol.for("react.memo"),ad=Symbol.for("react.lazy"),bd=Symbol.for("react.scope"),cd=Symbol.for("react.debug_trace_mode"),dd=Symbol.for("react.offscreen"),
ed=Symbol.for("react.legacy_hidden"),fd=Symbol.for("react.cache"),gd=Symbol.for("react.default_value"),hd=Symbol.for("react.memo_cache_sentinel"),id=Symbol.for("react.postpone"),jd=Symbol.iterator;
function kd(a){if(null==a)return null;if("function"===typeof a)return a.displayName||a.name||null;if("string"===typeof a)return a;switch(a){case wc:return"Fragment";case vc:return"Portal";case yc:return"Profiler";case xc:return"StrictMode";case Dc:return"Suspense";case Ec:return"SuspenseList";case fd:return"Cache"}if("object"===typeof a)switch(a.$$typeof){case Ac:return(a.displayName||"Context")+".Consumer";case zc:return(a._context.displayName||"Context")+".Provider";case Cc:var b=a.render;a=a.displayName;
a||(a=b.displayName||b.name||"",a=""!==a?"ForwardRef("+a+")":"ForwardRef");return a;case Fc:return b=a.displayName||null,null!==b?b:kd(a.type)||"Memo";case ad:b=a._payload;a=a._init;try{return kd(a(b))}catch(c){break}case Bc:return(a.displayName||a._globalName)+".Provider"}return null}var ld={};function md(a,b){a=a.contextTypes;if(!a)return ld;var c={},d;for(d in a)c[d]=b[d];return c}var nd=null;
function od(a,b){if(a!==b){a.context._currentValue2=a.parentValue;a=a.parent;var c=b.parent;if(null===a){if(null!==c)throw Error("The stacks must reach the root at the same time. This is a bug in React.");}else{if(null===c)throw Error("The stacks must reach the root at the same time. This is a bug in React.");od(a,c)}b.context._currentValue2=b.value}}function pd(a){a.context._currentValue2=a.parentValue;a=a.parent;null!==a&&pd(a)}
function qd(a){var b=a.parent;null!==b&&qd(b);a.context._currentValue2=a.value}function rd(a,b){a.context._currentValue2=a.parentValue;a=a.parent;if(null===a)throw Error("The depth must equal at least at zero before reaching the root. This is a bug in React.");a.depth===b.depth?od(a,b):rd(a,b)}
function sd(a,b){var c=b.parent;if(null===c)throw Error("The depth must equal at least at zero before reaching the root. This is a bug in React.");a.depth===c.depth?od(a,c):sd(a,c);b.context._currentValue2=b.value}function td(a){var b=nd;b!==a&&(null===b?qd(a):null===a?pd(b):b.depth===a.depth?od(b,a):b.depth>a.depth?rd(b,a):sd(b,a),nd=a)}
var ud={isMounted:function(){return!1},enqueueSetState:function(a,b){a=a._reactInternals;null!==a.queue&&a.queue.push(b)},enqueueReplaceState:function(a,b){a=a._reactInternals;a.replace=!0;a.queue=[b]},enqueueForceUpdate:function(){}};
function vd(a,b,c,d){var e=void 0!==a.state?a.state:null;a.updater=ud;a.props=c;a.state=e;var f={queue:[],replace:!1};a._reactInternals=f;var g=b.contextType;a.context="object"===typeof g&&null!==g?g._currentValue2:d;g=b.getDerivedStateFromProps;"function"===typeof g&&(g=g(c,e),e=null===g||void 0===g?e:r({},e,g),a.state=e);if("function"!==typeof b.getDerivedStateFromProps&&"function"!==typeof a.getSnapshotBeforeUpdate&&("function"===typeof a.UNSAFE_componentWillMount||"function"===typeof a.componentWillMount))if(b=
a.state,"function"===typeof a.componentWillMount&&a.componentWillMount(),"function"===typeof a.UNSAFE_componentWillMount&&a.UNSAFE_componentWillMount(),b!==a.state&&ud.enqueueReplaceState(a,a.state,null),null!==f.queue&&0<f.queue.length)if(b=f.queue,g=f.replace,f.queue=null,f.replace=!1,g&&1===b.length)a.state=b[0];else{f=g?b[0]:a.state;e=!0;for(g=g?1:0;g<b.length;g++){var h=b[g];h="function"===typeof h?h.call(a,f,c,d):h;null!=h&&(e?(e=!1,f=r({},f,h)):r(f,h))}a.state=f}else f.queue=null}
var wd={id:1,overflow:""};function xd(a,b,c){var d=a.id;a=a.overflow;var e=32-yd(d)-1;d&=~(1<<e);c+=1;var f=32-yd(b)+e;if(30<f){var g=e-e%5;f=(d&(1<<g)-1).toString(32);d>>=g;e-=g;return{id:1<<32-yd(b)+e|c<<e|d,overflow:f+a}}return{id:1<<f|c<<e|d,overflow:a}}var yd=Math.clz32?Math.clz32:zd,Ad=Math.log,Bd=Math.LN2;function zd(a){a>>>=0;return 0===a?32:31-(Ad(a)/Bd|0)|0}var Cd=Error("Suspense Exception: This is not a real error! It's an implementation detail of `use` to interrupt the current render. You must either rethrow it immediately, or move the `use` call outside of the `try/catch` block. Capturing without rethrowing will lead to unexpected behavior.\n\nTo handle async errors, wrap your component in an error boundary, or call the promise's `.catch` method and pass the result to `use`");
function Dd(){}function Ed(a,b,c){c=a[c];void 0===c?a.push(b):c!==b&&(b.then(Dd,Dd),b=c);switch(b.status){case "fulfilled":return b.value;case "rejected":throw b.reason;default:if("string"!==typeof b.status)switch(a=b,a.status="pending",a.then(function(d){if("pending"===b.status){var e=b;e.status="fulfilled";e.value=d}},function(d){if("pending"===b.status){var e=b;e.status="rejected";e.reason=d}}),b.status){case "fulfilled":return b.value;case "rejected":throw b.reason;}Fd=b;throw Cd;}}var Fd=null;
function Gd(){if(null===Fd)throw Error("Expected a suspended thenable. This is a bug in React. Please file an issue.");var a=Fd;Fd=null;return a}function Hd(a,b){return a===b&&(0!==a||1/a===1/b)||a!==a&&b!==b}var Id="function"===typeof Object.is?Object.is:Hd,S=null,Jd=null,Kd=null,Ld=null,Md=null,T=null,Nd=!1,Od=!1,Pd=0,Qd=0,Rd=-1,Sd=0,Td=null,Ud=null,Vd=0;
function Wd(){if(null===S)throw Error("Invalid hook call. Hooks can only be called inside of the body of a function component. This could happen for one of the following reasons:\n1. You might have mismatching versions of React and the renderer (such as React DOM)\n2. You might be breaking the Rules of Hooks\n3. You might have more than one copy of React in the same app\nSee https://reactjs.org/link/invalid-hook-call for tips about how to debug and fix this problem.");return S}
function Xd(){if(0<Vd)throw Error("Rendered more hooks than during the previous render");return{memoizedState:null,queue:null,next:null}}function Yd(){null===T?null===Md?(Nd=!1,Md=T=Xd()):(Nd=!0,T=Md):null===T.next?(Nd=!1,T=T.next=Xd()):(Nd=!0,T=T.next);return T}function Zd(a,b,c,d){for(;Od;)Od=!1,Qd=Pd=0,Rd=-1,Sd=0,Vd+=1,T=null,c=a(b,d);$d();return c}function ae(){var a=Td;Td=null;return a}function $d(){Ld=Kd=Jd=S=null;Od=!1;Md=null;Vd=0;T=Ud=null}
function be(a,b){return"function"===typeof b?b(a):b}function ce(a,b,c){S=Wd();T=Yd();if(Nd){var d=T.queue;b=d.dispatch;if(null!==Ud&&(c=Ud.get(d),void 0!==c)){Ud.delete(d);d=T.memoizedState;do d=a(d,c.action),c=c.next;while(null!==c);T.memoizedState=d;return[d,b]}return[T.memoizedState,b]}a=a===be?"function"===typeof b?b():b:void 0!==c?c(b):b;T.memoizedState=a;a=T.queue={last:null,dispatch:null};a=a.dispatch=de.bind(null,S,a);return[T.memoizedState,a]}
function ee(a,b){S=Wd();T=Yd();b=void 0===b?null:b;if(null!==T){var c=T.memoizedState;if(null!==c&&null!==b){var d=c[1];a:if(null===d)d=!1;else{for(var e=0;e<d.length&&e<b.length;e++)if(!Id(b[e],d[e])){d=!1;break a}d=!0}if(d)return c[0]}}a=a();T.memoizedState=[a,b];return a}
function de(a,b,c){if(25<=Vd)throw Error("Too many re-renders. React limits the number of renders to prevent an infinite loop.");if(a===S)if(Od=!0,a={action:c,next:null},null===Ud&&(Ud=new Map),c=Ud.get(b),void 0===c)Ud.set(b,a);else{for(b=c;null!==b.next;)b=b.next;b.next=a}}function fe(){throw Error("A function wrapped in useEffectEvent can't be called during rendering.");}function ge(){throw Error("startTransition cannot be called during server rendering.");}
function he(){throw Error("Cannot update optimistic state while rendering.");}function ie(a){var b=Sd;Sd+=1;null===Td&&(Td=[]);return Ed(Td,a,b)}function je(){throw Error("Cache cannot be refreshed during server rendering.");}function ke(){}
var me={readContext:function(a){return a._currentValue2},use:function(a){if(null!==a&&"object"===typeof a){if("function"===typeof a.then)return ie(a);if(a.$$typeof===Ac||a.$$typeof===Bc)return a._currentValue2}throw Error("An unsupported type was passed to use(): "+String(a));},useContext:function(a){Wd();return a._currentValue2},useMemo:ee,useReducer:ce,useRef:function(a){S=Wd();T=Yd();var b=T.memoizedState;return null===b?(a={current:a},T.memoizedState=a):b},useState:function(a){return ce(be,a)},
useInsertionEffect:ke,useLayoutEffect:ke,useCallback:function(a,b){return ee(function(){return a},b)},useImperativeHandle:ke,useEffect:ke,useDebugValue:ke,useDeferredValue:function(a,b){Wd();return void 0!==b?b:a},useTransition:function(){Wd();return[!1,ge]},useId:function(){var a=Jd.treeContext;var b=a.overflow;a=a.id;a=(a&~(1<<32-yd(a)-1)).toString(32)+b;var c=le;if(null===c)throw Error("Invalid hook call. Hooks can only be called inside of the body of a function component.");b=Pd++;a=":"+c.idPrefix+
"R"+a;0<b&&(a+="H"+b.toString(32));return a+":"},useSyncExternalStore:function(a,b,c){if(void 0===c)throw Error("Missing getServerSnapshot, which is required for server-rendered content. Will revert to client rendering.");return c()},useCacheRefresh:function(){return je},useEffectEvent:function(){return fe},useMemoCache:function(a){for(var b=Array(a),c=0;c<a;c++)b[c]=hd;return b},useHostTransitionStatus:function(){Wd();return Ja},useOptimistic:function(a){Wd();return[a,he]},useFormState:function(a,
b,c){Wd();var d=Qd++,e=Kd;if("function"===typeof a.$$FORM_ACTION){var f=null,g=Ld;e=e.formState;var h=a.$$IS_SIGNATURE_EQUAL;if(null!==e&&"function"===typeof h){var k=e[1];h.call(a,e[2],e[3])&&(f=void 0!==c?"p"+c:"k"+ka(JSON.stringify([g,null,d]),0),k===f&&(Rd=d,b=e[0]))}var l=a.bind(null,b);a=function(q){l(q)};"function"===typeof l.$$FORM_ACTION&&(a.$$FORM_ACTION=function(q){q=l.$$FORM_ACTION(q);void 0!==c&&(c+="",q.action=c);var m=q.data;m&&(null===f&&(f=void 0!==c?"p"+c:"k"+ka(JSON.stringify([g,
null,d]),0)),m.append("$ACTION_KEY",f));return q});return[b,a]}var n=a.bind(null,b);return[b,function(q){n(q)}]}},le=null,oe={getCacheSignal:function(){throw Error("Not implemented.");},getCacheForType:function(){throw Error("Not implemented.");}},pe=Ia.ReactCurrentDispatcher,qe=Ia.ReactCurrentCache;function re(a){console.error(a);return null}function se(){}
function te(a,b,c,d,e,f,g,h,k,l,n,q){Ka.current=jb;var m=[],y=new Set;b={destination:null,flushScheduled:!1,resumableState:b,renderState:c,rootFormatContext:d,progressiveChunkSize:void 0===e?12800:e,status:0,fatalError:null,nextSegmentId:0,allPendingTasks:0,pendingRootTasks:0,completedRootSegment:null,abortableTasks:y,pingedTasks:m,clientRenderedBoundaries:[],completedBoundaries:[],partialBoundaries:[],trackedPostpones:null,onError:void 0===f?re:f,onPostpone:void 0===n?se:n,onAllReady:void 0===g?
se:g,onShellReady:void 0===h?se:h,onShellError:void 0===k?se:k,onFatalError:void 0===l?se:l,formState:void 0===q?null:q};c=ue(b,0,null,d,!1,!1);c.parentFlushed=!0;a=ve(b,null,a,-1,null,c,y,null,d,ld,null,wd);m.push(a);return b}var L=null;function we(a,b){a.pingedTasks.push(b);1===a.pingedTasks.length&&(a.flushScheduled=null!==a.destination,xe(a))}
function ye(a,b){return{status:0,rootSegmentID:-1,parentFlushed:!1,pendingTasks:0,completedSegments:[],byteSize:0,fallbackAbortableTasks:b,errorDigest:null,resources:{styles:new Set,stylesheets:new Set},trackedContentKeyPath:null,trackedFallbackNode:null}}
function ve(a,b,c,d,e,f,g,h,k,l,n,q){a.allPendingTasks++;null===e?a.pendingRootTasks++:e.pendingTasks++;var m={replay:null,node:c,childIndex:d,ping:function(){return we(a,m)},blockedBoundary:e,blockedSegment:f,abortSet:g,keyPath:h,formatContext:k,legacyContext:l,context:n,treeContext:q,thenableState:b};g.add(m);return m}
function ze(a,b,c,d,e,f,g,h,k,l,n,q){a.allPendingTasks++;null===f?a.pendingRootTasks++:f.pendingTasks++;c.pendingTasks++;var m={replay:c,node:d,childIndex:e,ping:function(){return we(a,m)},blockedBoundary:f,blockedSegment:null,abortSet:g,keyPath:h,formatContext:k,legacyContext:l,context:n,treeContext:q,thenableState:b};g.add(m);return m}function ue(a,b,c,d,e,f){return{status:0,id:-1,index:b,parentFlushed:!1,chunks:[],children:[],parentFormatContext:d,boundary:c,lastPushedText:e,textEmbedded:f}}
function W(a,b){a=a.onError(b);if(null!=a&&"string"!==typeof a)throw Error('onError returned something with a type other than "string". onError should return a string and may return null or undefined but must not return anything else. It received something of type "'+typeof a+'" instead');return a}function Ae(a,b){var c=a.onShellError;c(b);c=a.onFatalError;c(b);null!==a.destination?(a.status=2,a.destination.destroy(b)):(a.status=1,a.fatalError=b)}
function Be(a,b,c,d,e){var f=d.render(),g=e.childContextTypes;if(null!==g&&void 0!==g){c=b.legacyContext;if("function"!==typeof d.getChildContext)e=c;else{d=d.getChildContext();for(var h in d)if(!(h in g))throw Error((kd(e)||"Unknown")+'.getChildContext(): key "'+h+'" is not defined in childContextTypes.');e=r({},c,d)}b.legacyContext=e;X(a,b,null,f,-1);b.legacyContext=c}else e=b.keyPath,b.keyPath=c,X(a,b,null,f,-1),b.keyPath=e}
function Ce(a,b,c,d,e,f,g){var h=!1;if(0!==f&&null!==a.formState){var k=b.blockedSegment;if(null!==k){h=!0;k=k.chunks;for(var l=0;l<f;l++)l===g?k.push("\x3c!--F!--\x3e"):k.push("\x3c!--F--\x3e")}}f=b.keyPath;b.keyPath=c;e?(c=b.treeContext,b.treeContext=xd(c,1,0),Y(a,b,d,-1),b.treeContext=c):h?Y(a,b,d,-1):X(a,b,null,d,-1);b.keyPath=f}function De(a,b){if(a&&a.defaultProps){b=r({},b);a=a.defaultProps;for(var c in a)void 0===b[c]&&(b[c]=a[c]);return b}return b}
function Ee(a,b,c,d,e,f,g){if("function"===typeof e)if(e.prototype&&e.prototype.isReactComponent){d=md(e,b.legacyContext);var h=e.contextType;h=new e(f,"object"===typeof h&&null!==h?h._currentValue2:d);vd(h,e,f,d);Be(a,b,c,h,e)}else{h=md(e,b.legacyContext);S={};Jd=b;Kd=a;Ld=c;Qd=Pd=0;Rd=-1;Sd=0;Td=d;d=e(f,h);d=Zd(e,f,d,h);g=0!==Pd;var k=Qd,l=Rd;"object"===typeof d&&null!==d&&"function"===typeof d.render&&void 0===d.$$typeof?(vd(d,e,f,h),Be(a,b,c,d,e)):Ce(a,b,c,d,g,k,l)}else if("string"===typeof e)if(d=
b.blockedSegment,null===d)d=f.children,h=b.formatContext,g=b.keyPath,b.formatContext=nb(h,e,f),b.keyPath=c,Y(a,b,d,-1),b.formatContext=h,b.keyPath=g;else{g=Ob(d.chunks,e,f,a.resumableState,a.renderState,b.formatContext,d.lastPushedText);d.lastPushedText=!1;h=b.formatContext;k=b.keyPath;b.formatContext=nb(h,e,f);b.keyPath=c;Y(a,b,g,-1);b.formatContext=h;b.keyPath=k;a:{b=d.chunks;a=a.resumableState;switch(e){case "title":case "style":case "script":case "area":case "base":case "br":case "col":case "embed":case "hr":case "img":case "input":case "keygen":case "link":case "meta":case "param":case "source":case "track":case "wbr":break a;
case "body":if(1>=h.insertionMode){a.hasBody=!0;break a}break;case "html":if(0===h.insertionMode){a.hasHtml=!0;break a}}b.push("</",e,">")}d.lastPushedText=!1}else{switch(e){case ed:case cd:case xc:case yc:case wc:e=b.keyPath;b.keyPath=c;X(a,b,null,f.children,-1);b.keyPath=e;return;case dd:"hidden"!==f.mode&&(e=b.keyPath,b.keyPath=c,X(a,b,null,f.children,-1),b.keyPath=e);return;case Ec:e=b.keyPath;b.keyPath=c;X(a,b,null,f.children,-1);b.keyPath=e;return;case bd:throw Error("ReactDOMServer does not yet support scope components.");
case Dc:a:if(null!==b.replay){e=b.keyPath;b.keyPath=c;c=f.children;try{Y(a,b,c,-1)}finally{b.keyPath=e}}else{l=b.keyPath;e=b.blockedBoundary;var n=b.blockedSegment;d=f.fallback;var q=f.children;f=new Set;g=ye(a,f);null!==a.trackedPostpones&&(g.trackedContentKeyPath=c);k=ue(a,n.chunks.length,g,b.formatContext,!1,!1);n.children.push(k);n.lastPushedText=!1;var m=ue(a,0,null,b.formatContext,!1,!1);m.parentFlushed=!0;b.blockedBoundary=g;b.blockedSegment=m;a.renderState.boundaryResources=g.resources;b.keyPath=
c;try{if(Y(a,b,q,-1),a.renderState.generateStaticMarkup||m.lastPushedText&&m.textEmbedded&&m.chunks.push("\x3c!-- --\x3e"),m.status=1,Fe(g,m),0===g.pendingTasks&&0===g.status){g.status=1;break a}}catch(y){m.status=4,g.status=4,"object"===typeof y&&null!==y&&y.$$typeof===id?(a.onPostpone(y.message),h="POSTPONE"):h=W(a,y),g.errorDigest=h}finally{a.renderState.boundaryResources=e?e.resources:null,b.blockedBoundary=e,b.blockedSegment=n,b.keyPath=l}h=[c[0],"Suspense Fallback",c[2]];l=a.trackedPostpones;
null!==l&&(n=[h[1],h[2],[],null],l.workingMap.set(h,n),5===g.status?l.workingMap.get(c)[4]=n:g.trackedFallbackNode=n);b=ve(a,null,d,-1,e,k,f,h,b.formatContext,b.legacyContext,b.context,b.treeContext);a.pingedTasks.push(b)}return}if("object"===typeof e&&null!==e)switch(e.$$typeof){case Cc:e=e.render;S={};Jd=b;Kd=a;Ld=c;Qd=Pd=0;Rd=-1;Sd=0;Td=d;d=e(f,g);f=Zd(e,f,d,g);Ce(a,b,c,f,0!==Pd,Qd,Rd);return;case Fc:e=e.type;f=De(e,f);Ee(a,b,c,d,e,f,g);return;case zc:h=f.children;d=b.keyPath;e=e._context;f=f.value;
g=e._currentValue2;e._currentValue2=f;k=nd;nd=f={parent:k,depth:null===k?0:k.depth+1,context:e,parentValue:g,value:f};b.context=f;b.keyPath=c;X(a,b,null,h,-1);a=nd;if(null===a)throw Error("Tried to pop a Context at the root of the app. This is a bug in React.");c=a.parentValue;a.context._currentValue2=c===gd?a.context._defaultValue:c;a=nd=a.parent;b.context=a;b.keyPath=d;return;case Ac:f=f.children;f=f(e._currentValue2);e=b.keyPath;b.keyPath=c;X(a,b,null,f,-1);b.keyPath=e;return;case ad:h=e._init;
e=h(e._payload);f=De(e,f);Ee(a,b,c,d,e,f,void 0);return}throw Error("Element type is invalid: expected a string (for built-in components) or a class/function (for composite components) but got: "+((null==e?e:typeof e)+"."));}}
function Ge(a,b,c,d,e){var f=b.replay,g=b.blockedBoundary,h=ue(a,0,null,b.formatContext,!1,!1);h.id=c;h.parentFlushed=!0;try{b.replay=null,b.blockedSegment=h,Y(a,b,d,e),h.status=1,null===g?a.completedRootSegment=h:(Fe(g,h),g.parentFlushed&&a.partialBoundaries.push(g))}finally{b.replay=f,b.blockedSegment=null}}
function X(a,b,c,d,e){if(null!==b.replay&&"number"===typeof b.replay.slots)Ge(a,b,b.replay.slots,d,e);else{b.node=d;b.childIndex=e;if("object"===typeof d&&null!==d){switch(d.$$typeof){case uc:var f=d.type,g=d.key,h=d.props,k=d.ref,l=kd(f),n=null==g?-1===e?0:e:g;g=[b.keyPath,l,n];if(null!==b.replay)a:{var q=b.replay;e=q.nodes;for(d=0;d<e.length;d++){var m=e[d];if(n===m[1]){if(4===m.length){if(null!==l&&l!==m[0])throw Error("Expected the resume to render <"+m[0]+"> in this slot but instead it rendered <"+
l+">. The tree doesn't match so React will fallback to client rendering.");l=m[2];m=m[3];n=b.node;b.replay={nodes:l,slots:m,pendingTasks:1};try{Ee(a,b,g,c,f,h,k);if(1===b.replay.pendingTasks&&0<b.replay.nodes.length)throw Error("Couldn't find all resumable slots by key/index during replaying. The tree doesn't match so React will fallback to client rendering.");b.replay.pendingTasks--}catch(t){if("object"===typeof t&&null!==t&&(t===Cd||"function"===typeof t.then))throw b.node===n&&(b.replay=q),t;b.replay.pendingTasks--;
He(a,b.blockedBoundary,t,l,m)}b.replay=q}else{if(f!==Dc)throw Error("Expected the resume to render <Suspense> in this slot but instead it rendered <"+(kd(f)||"Unknown")+">. The tree doesn't match so React will fallback to client rendering.");b:{c=void 0;f=m[5];k=m[2];q=m[3];l=null===m[4]?[]:m[4][2];m=null===m[4]?null:m[4][3];n=b.keyPath;var y=b.replay,A=b.blockedBoundary,Q=h.children;h=h.fallback;var M=new Set,p=ye(a,M);p.parentFlushed=!0;p.rootSegmentID=f;b.blockedBoundary=p;b.replay={nodes:k,slots:q,
pendingTasks:1};a.renderState.boundaryResources=p.resources;try{Y(a,b,Q,-1);if(1===b.replay.pendingTasks&&0<b.replay.nodes.length)throw Error("Couldn't find all resumable slots by key/index during replaying. The tree doesn't match so React will fallback to client rendering.");b.replay.pendingTasks--;if(0===p.pendingTasks&&0===p.status){p.status=1;a.completedBoundaries.push(p);break b}}catch(t){p.status=4,"object"===typeof t&&null!==t&&t.$$typeof===id?(a.onPostpone(t.message),c="POSTPONE"):c=W(a,t),
p.errorDigest=c,b.replay.pendingTasks--,a.clientRenderedBoundaries.push(p)}finally{a.renderState.boundaryResources=A?A.resources:null,b.blockedBoundary=A,b.replay=y,b.keyPath=n}h=ze(a,null,{nodes:l,slots:m,pendingTasks:0},h,-1,A,M,[g[0],"Suspense Fallback",g[2]],b.formatContext,b.legacyContext,b.context,b.treeContext);a.pingedTasks.push(h)}}e.splice(d,1);break a}}}else Ee(a,b,g,c,f,h,k);return;case vc:throw Error("Portals are not currently supported by the server renderer. Render them conditionally so that they only appear on the client render.");
case ad:h=d._init;d=h(d._payload);X(a,b,null,d,e);return}if(Ha(d)){Ie(a,b,d,e);return}null===d||"object"!==typeof d?h=null:(h=jd&&d[jd]||d["@@iterator"],h="function"===typeof h?h:null);if(h&&(h=h.call(d))){d=h.next();if(!d.done){g=[];do g.push(d.value),d=h.next();while(!d.done);Ie(a,b,g,e)}return}if("function"===typeof d.then)return X(a,b,null,ie(d),e);if(d.$$typeof===Ac||d.$$typeof===Bc)return X(a,b,null,d._currentValue2,e);e=Object.prototype.toString.call(d);throw Error("Objects are not valid as a React child (found: "+
("[object Object]"===e?"object with keys {"+Object.keys(d).join(", ")+"}":e)+"). If you meant to render a collection of children, use an array instead.");}"string"===typeof d?(e=b.blockedSegment,null!==e&&(e.lastPushedText=tc(e.chunks,d,a.renderState,e.lastPushedText))):"number"===typeof d&&(e=b.blockedSegment,null!==e&&(e.lastPushedText=tc(e.chunks,""+d,a.renderState,e.lastPushedText)))}}
function Ie(a,b,c,d){var e=b.keyPath;if(-1!==d&&(b.keyPath=[b.keyPath,"Fragment",d],null!==b.replay)){for(var f=b.replay,g=f.nodes,h=0;h<g.length;h++){var k=g[h];if(k[1]===d){d=k[2];k=k[3];b.replay={nodes:d,slots:k,pendingTasks:1};try{Ie(a,b,c,-1);if(1===b.replay.pendingTasks&&0<b.replay.nodes.length)throw Error("Couldn't find all resumable slots by key/index during replaying. The tree doesn't match so React will fallback to client rendering.");b.replay.pendingTasks--}catch(n){if("object"===typeof n&&
null!==n&&(n===Cd||"function"===typeof n.then))throw n;b.replay.pendingTasks--;He(a,b.blockedBoundary,n,d,k)}b.replay=f;g.splice(h,1);break}}b.keyPath=e;return}f=b.treeContext;g=c.length;if(null!==b.replay&&(h=b.replay.slots,null!==h&&"object"===typeof h)){for(k=0;k<g;k++){d=c[k];b.treeContext=xd(f,g,k);var l=h[k];"number"===typeof l?(Ge(a,b,l,d,k),delete h[k]):Y(a,b,d,k)}b.treeContext=f;b.keyPath=e;return}for(h=0;h<g;h++)k=c[h],b.treeContext=xd(f,g,h),Y(a,b,k,h);b.treeContext=f;b.keyPath=e}
function Je(a,b,c,d){d.status=5;var e=c.keyPath,f=c.blockedBoundary;if(null!==f&&0===f.status){f.status=5;f.rootSegmentID=a.nextSegmentId++;var g=f.trackedContentKeyPath;if(null===g)throw Error("It should not be possible to postpone at the root. This is a bug in React.");var h=f.trackedFallbackNode,k=[];if(g===e&&-1===c.childIndex){d.id=f.rootSegmentID;d=[g[1],g[2],k,f.rootSegmentID,h,f.rootSegmentID];b.workingMap.set(g,d);Ke(d,g[0],b);return}var l=b.workingMap.get(g);void 0===l?(l=[g[1],g[2],k,null,
h,f.rootSegmentID],b.workingMap.set(g,l),Ke(l,g[0],b)):(g=l,g[4]=h,g[5]=f.rootSegmentID)}-1===d.id&&(d.id=d.parentFlushed&&null!==f?f.rootSegmentID:a.nextSegmentId++);if(-1===c.childIndex)null===e?b.rootSlots=d.id:(c=b.workingMap.get(e),void 0===c?(c=[e[1],e[2],[],d.id],Ke(c,e[0],b)):c[3]=d.id);else{if(null===e)if(a=b.rootSlots,null===a)a=b.rootSlots={};else{if("number"===typeof a)throw Error("It should not be possible to postpone both at the root of an element as well as a slot below. This is a bug in React.");
}else if(f=b.workingMap,g=f.get(e),void 0===g)a={},g=[e[1],e[2],[],a],f.set(e,g),Ke(g,e[0],b);else if(a=g[3],null===a)a=g[3]={};else if("number"===typeof a)throw Error("It should not be possible to postpone both at the root of an element as well as a slot below. This is a bug in React.");a[c.childIndex]=d.id}}
function Y(a,b,c,d){var e=b.formatContext,f=b.legacyContext,g=b.context,h=b.keyPath,k=b.treeContext,l=b.blockedSegment;if(null===l)try{return X(a,b,null,c,d)}catch(m){if($d(),d=m===Cd?Gd():m,"object"===typeof d&&null!==d&&"function"===typeof d.then){c=d;d=ae();a=ze(a,d,b.replay,b.node,b.childIndex,b.blockedBoundary,b.abortSet,b.keyPath,b.formatContext,b.legacyContext,b.context,b.treeContext).ping;c.then(a,a);b.formatContext=e;b.legacyContext=f;b.context=g;b.keyPath=h;b.treeContext=k;td(g);return}}else{var n=
l.children.length,q=l.chunks.length;try{return X(a,b,null,c,d)}catch(m){if($d(),l.children.length=n,l.chunks.length=q,d=m===Cd?Gd():m,"object"===typeof d&&null!==d){if("function"===typeof d.then){c=d;d=ae();l=b.blockedSegment;n=ue(a,l.chunks.length,null,b.formatContext,l.lastPushedText,!0);l.children.push(n);l.lastPushedText=!1;a=ve(a,d,b.node,b.childIndex,b.blockedBoundary,n,b.abortSet,b.keyPath,b.formatContext,b.legacyContext,b.context,b.treeContext).ping;c.then(a,a);b.formatContext=e;b.legacyContext=
f;b.context=g;b.keyPath=h;b.treeContext=k;td(g);return}if(null!==a.trackedPostpones&&d.$$typeof===id&&null!==b.blockedBoundary){c=a.trackedPostpones;a.onPostpone(d.message);d=b.blockedSegment;l=ue(a,d.chunks.length,null,b.formatContext,d.lastPushedText,!0);d.children.push(l);d.lastPushedText=!1;Je(a,c,b,l);b.formatContext=e;b.legacyContext=f;b.context=g;b.keyPath=h;b.treeContext=k;td(g);return}}}}b.formatContext=e;b.legacyContext=f;b.context=g;b.keyPath=h;b.treeContext=k;td(g);throw d;}
function He(a,b,c,d,e){if("object"===typeof c&&null!==c&&c.$$typeof===id){a.onPostpone(c.message);var f="POSTPONE"}else f=W(a,c);Le(a,b,d,e,c,f)}function Me(a){var b=a.blockedBoundary;a=a.blockedSegment;null!==a&&(a.status=3,Ne(this,b,a))}
function Le(a,b,c,d,e,f){for(var g=0;g<c.length;g++){var h=c[g];if(4===h.length)Le(a,b,h[2],h[3],e,f);else{h=h[5];var k=a,l=f,n=ye(k,new Set);n.parentFlushed=!0;n.rootSegmentID=h;n.status=4;n.errorDigest=l;n.parentFlushed&&k.clientRenderedBoundaries.push(n)}}c.length=0;if(null!==d){if(null===b)throw Error("We should not have any resumable nodes in the shell. This is a bug in React.");4!==b.status&&(b.status=4,b.errorDigest=f,b.parentFlushed&&a.clientRenderedBoundaries.push(b));if("object"===typeof d)for(var q in d)delete d[q]}}
function Oe(a,b,c){var d=a.blockedBoundary,e=a.blockedSegment;null!==e&&(e.status=3);if(null===d){if(1!==b.status&&2!==b.status){a=a.replay;if(null===a){W(b,c);Ae(b,c);return}a.pendingTasks--;0===a.pendingTasks&&0<a.nodes.length&&(d=W(b,c),Le(b,null,a.nodes,a.slots,c,d));b.pendingRootTasks--;0===b.pendingRootTasks&&(b.onShellError=se,a=b.onShellReady,a())}}else d.pendingTasks--,4!==d.status&&(d.status=4,d.errorDigest=W(b,c),d.parentFlushed&&b.clientRenderedBoundaries.push(d)),d.fallbackAbortableTasks.forEach(function(f){return Oe(f,
b,c)}),d.fallbackAbortableTasks.clear();b.allPendingTasks--;0===b.allPendingTasks&&(a=b.onAllReady,a())}function Fe(a,b){if(0===b.chunks.length&&1===b.children.length&&null===b.children[0].boundary){var c=b.children[0];c.id=b.id;c.parentFlushed=!0;1===c.status&&Fe(a,c)}else a.completedSegments.push(b)}
function Ne(a,b,c){if(null===b){if(null!==c&&c.parentFlushed){if(null!==a.completedRootSegment)throw Error("There can only be one root segment. This is a bug in React.");a.completedRootSegment=c}a.pendingRootTasks--;0===a.pendingRootTasks&&(a.onShellError=se,b=a.onShellReady,b())}else b.pendingTasks--,4!==b.status&&(0===b.pendingTasks?(0===b.status&&(b.status=1),null!==c&&c.parentFlushed&&1===c.status&&Fe(b,c),b.parentFlushed&&a.completedBoundaries.push(b),1===b.status&&(b.fallbackAbortableTasks.forEach(Me,
a),b.fallbackAbortableTasks.clear())):null!==c&&c.parentFlushed&&1===c.status&&(Fe(b,c),1===b.completedSegments.length&&b.parentFlushed&&a.partialBoundaries.push(b)));a.allPendingTasks--;0===a.allPendingTasks&&(a=a.onAllReady,a())}
function xe(a){if(2!==a.status){var b=nd,c=pe.current;pe.current=me;var d=qe.current;qe.current=oe;var e=L;L=a;var f=le;le=a.resumableState;try{var g=a.pingedTasks,h;for(h=0;h<g.length;h++){var k=g[h],l=a,n=k.blockedBoundary;l.renderState.boundaryResources=n?n.resources:null;var q=k.blockedSegment;if(null===q){var m=l;if(0!==k.replay.pendingTasks){td(k.context);try{var y=k.thenableState;k.thenableState=null;X(m,k,y,k.node,-1);if(1===k.replay.pendingTasks&&0<k.replay.nodes.length)throw Error("Couldn't find all resumable slots by key/index during replaying. The tree doesn't match so React will fallback to client rendering.");
k.replay.pendingTasks--;k.abortSet.delete(k);Ne(m,k.blockedBoundary,null)}catch(G){$d();var A=G===Cd?Gd():G;if("object"===typeof A&&null!==A&&"function"===typeof A.then){var Q=k.ping;A.then(Q,Q);k.thenableState=ae()}else{k.replay.pendingTasks--;k.abortSet.delete(k);He(m,k.blockedBoundary,A,k.replay.nodes,k.replay.slots);m.pendingRootTasks--;if(0===m.pendingRootTasks){m.onShellError=se;var M=m.onShellReady;M()}m.allPendingTasks--;if(0===m.allPendingTasks){var p=m.onAllReady;p()}}}finally{m.renderState.boundaryResources=
null}}}else a:{m=void 0;var t=q;if(0===t.status){td(k.context);var Z=t.children.length,F=t.chunks.length;try{var N=k.thenableState;k.thenableState=null;X(l,k,N,k.node,k.childIndex);l.renderState.generateStaticMarkup||t.lastPushedText&&t.textEmbedded&&t.chunks.push("\x3c!-- --\x3e");k.abortSet.delete(k);t.status=1;Ne(l,k.blockedBoundary,t)}catch(G){$d();t.children.length=Z;t.chunks.length=F;var u=G===Cd?Gd():G;if("object"===typeof u&&null!==u){if("function"===typeof u.then){var z=k.ping;u.then(z,z);
k.thenableState=ae();break a}if(null!==l.trackedPostpones&&u.$$typeof===id&&null!==k.blockedBoundary){var U=l.trackedPostpones;k.abortSet.delete(k);l.onPostpone(u.message);Je(l,U,k,t);Ne(l,k.blockedBoundary,t);break a}}k.abortSet.delete(k);t.status=4;var P=k.blockedBoundary;"object"===typeof u&&null!==u&&u.$$typeof===id?(l.onPostpone(u.message),m="POSTPONE"):m=W(l,u);null===P?Ae(l,u):(P.pendingTasks--,4!==P.status&&(P.status=4,P.errorDigest=m,P.parentFlushed&&l.clientRenderedBoundaries.push(P)));
l.allPendingTasks--;if(0===l.allPendingTasks){var da=l.onAllReady;da()}}finally{l.renderState.boundaryResources=null}}}}g.splice(0,h);null!==a.destination&&Pe(a,a.destination)}catch(G){W(a,G),Ae(a,G)}finally{le=f,pe.current=c,qe.current=d,c===me&&td(b),L=e}}}
function Qe(a,b,c){c.parentFlushed=!0;switch(c.status){case 0:c.id=a.nextSegmentId++;case 5:var d=c.id;c.lastPushedText=!1;c.textEmbedded=!1;a=a.renderState;b.push('<template id="');b.push(a.placeholderPrefix);a=d.toString(16);b.push(a);return b.push('"></template>');case 1:c.status=2;var e=!0;d=c.chunks;var f=0;c=c.children;for(var g=0;g<c.length;g++){for(e=c[g];f<e.index;f++)b.push(d[f]);e=Re(a,b,e)}for(;f<d.length-1;f++)b.push(d[f]);f<d.length&&(e=b.push(d[f]));return e;default:throw Error("Aborted, errored or already flushed boundaries should not be flushed again. This is a bug in React.");
}}
function Re(a,b,c){var d=c.boundary;if(null===d)return Qe(a,b,c);d.parentFlushed=!0;if(4===d.status)return a.renderState.generateStaticMarkup||(d=d.errorDigest,b.push("\x3c!--$!--\x3e"),b.push("<template"),d&&(b.push(' data-dgst="'),d=w(d),b.push(d),b.push('"')),b.push("></template>")),Qe(a,b,c),a=a.renderState.generateStaticMarkup?!0:b.push("\x3c!--/$--\x3e"),a;if(1!==d.status)return 0===d.status&&(d.rootSegmentID=a.nextSegmentId++),0<d.completedSegments.length&&a.partialBoundaries.push(d),Qb(b,a.renderState,
d.rootSegmentID),Qe(a,b,c),b.push("\x3c!--/$--\x3e");if(d.byteSize>a.progressiveChunkSize)return d.rootSegmentID=a.nextSegmentId++,a.completedBoundaries.push(d),Qb(b,a.renderState,d.rootSegmentID),Qe(a,b,c),b.push("\x3c!--/$--\x3e");c=d.resources;var e=a.renderState.boundaryResources;e&&(c.styles.forEach(qc,e),c.stylesheets.forEach(rc,e));a.renderState.generateStaticMarkup||b.push("\x3c!--$--\x3e");c=d.completedSegments;if(1!==c.length)throw Error("A previously unvisited boundary must have exactly one root segment. This is a bug in React.");
Re(a,b,c[0]);a=a.renderState.generateStaticMarkup?!0:b.push("\x3c!--/$--\x3e");return a}function Se(a,b,c){Rb(b,a.renderState,c.parentFormatContext,c.id);Re(a,b,c);return Sb(b,c.parentFormatContext)}
function Te(a,b,c){a.renderState.boundaryResources=c.resources;for(var d=c.completedSegments,e=0;e<d.length;e++)Ue(a,b,c,d[e]);d.length=0;hc(b,c.resources,a.renderState);d=a.resumableState;a=a.renderState;e=c.rootSegmentID;c=c.resources;var f=a.stylesToHoist;a.stylesToHoist=!1;var g=0===d.streamingFormat;g?(b.push(a.startInlineScript),f?0===(d.instructions&2)?(d.instructions|=10,b.push('$RC=function(b,c,e){c=document.getElementById(c);c.parentNode.removeChild(c);var a=document.getElementById(b);if(a){b=a.previousSibling;if(e)b.data="$!",a.setAttribute("data-dgst",e);else{e=b.parentNode;a=b.nextSibling;var f=0;do{if(a&&8===a.nodeType){var d=a.data;if("/$"===d)if(0===f)break;else f--;else"$"!==d&&"$?"!==d&&"$!"!==d||f++}d=a.nextSibling;e.removeChild(a);a=d}while(a);for(;c.firstChild;)e.insertBefore(c.firstChild,a);b.data="$"}b._reactRetry&&b._reactRetry()}};$RM=new Map;\n$RR=function(r,t,w){for(var u=$RC,n=$RM,p=new Map,q=document,g,b,h=q.querySelectorAll("link[data-precedence],style[data-precedence]"),v=[],k=0;b=h[k++];)"not all"===b.getAttribute("media")?v.push(b):("LINK"===b.tagName&&n.set(b.getAttribute("href"),b),p.set(b.dataset.precedence,g=b));b=0;h=[];var l,a;for(k=!0;;){if(k){var f=w[b++];if(!f){k=!1;b=0;continue}var c=!1,m=0;var d=f[m++];if(a=n.get(d)){var e=a._p;c=!0}else{a=q.createElement("link");a.href=d;a.rel="stylesheet";for(a.dataset.precedence=\nl=f[m++];e=f[m++];)a.setAttribute(e,f[m++]);e=a._p=new Promise(function(x,y){a.onload=x;a.onerror=y});n.set(d,a)}d=a.getAttribute("media");!e||"l"===e.s||d&&!matchMedia(d).matches||h.push(e);if(c)continue}else{a=v[b++];if(!a)break;l=a.getAttribute("data-precedence");a.removeAttribute("media")}c=p.get(l)||g;c===g&&(g=a);p.set(l,a);c?c.parentNode.insertBefore(a,c.nextSibling):(c=q.head,c.insertBefore(a,c.firstChild))}Promise.all(h).then(u.bind(null,r,t,""),u.bind(null,r,t,"Resource failed to load"))};$RR("')):
0===(d.instructions&8)?(d.instructions|=8,b.push('$RM=new Map;\n$RR=function(r,t,w){for(var u=$RC,n=$RM,p=new Map,q=document,g,b,h=q.querySelectorAll("link[data-precedence],style[data-precedence]"),v=[],k=0;b=h[k++];)"not all"===b.getAttribute("media")?v.push(b):("LINK"===b.tagName&&n.set(b.getAttribute("href"),b),p.set(b.dataset.precedence,g=b));b=0;h=[];var l,a;for(k=!0;;){if(k){var f=w[b++];if(!f){k=!1;b=0;continue}var c=!1,m=0;var d=f[m++];if(a=n.get(d)){var e=a._p;c=!0}else{a=q.createElement("link");a.href=d;a.rel="stylesheet";for(a.dataset.precedence=\nl=f[m++];e=f[m++];)a.setAttribute(e,f[m++]);e=a._p=new Promise(function(x,y){a.onload=x;a.onerror=y});n.set(d,a)}d=a.getAttribute("media");!e||"l"===e.s||d&&!matchMedia(d).matches||h.push(e);if(c)continue}else{a=v[b++];if(!a)break;l=a.getAttribute("data-precedence");a.removeAttribute("media")}c=p.get(l)||g;c===g&&(g=a);p.set(l,a);c?c.parentNode.insertBefore(a,c.nextSibling):(c=q.head,c.insertBefore(a,c.firstChild))}Promise.all(h).then(u.bind(null,r,t,""),u.bind(null,r,t,"Resource failed to load"))};$RR("')):
b.push('$RR("'):0===(d.instructions&2)?(d.instructions|=2,b.push('$RC=function(b,c,e){c=document.getElementById(c);c.parentNode.removeChild(c);var a=document.getElementById(b);if(a){b=a.previousSibling;if(e)b.data="$!",a.setAttribute("data-dgst",e);else{e=b.parentNode;a=b.nextSibling;var f=0;do{if(a&&8===a.nodeType){var d=a.data;if("/$"===d)if(0===f)break;else f--;else"$"!==d&&"$?"!==d&&"$!"!==d||f++}d=a.nextSibling;e.removeChild(a);a=d}while(a);for(;c.firstChild;)e.insertBefore(c.firstChild,a);b.data="$"}b._reactRetry&&b._reactRetry()}};$RC("')):
b.push('$RC("')):f?b.push('<template data-rri="" data-bid="'):b.push('<template data-rci="" data-bid="');d=e.toString(16);b.push(a.boundaryPrefix);b.push(d);g?b.push('","'):b.push('" data-sid="');b.push(a.segmentPrefix);b.push(d);f?g?(b.push('",'),nc(b,c)):(b.push('" data-sty="'),oc(b,c)):g&&b.push('"');d=g?b.push(")\x3c/script>"):b.push('"></template>');return Pb(b,a)&&d}
function Ue(a,b,c,d){if(2===d.status)return!0;var e=d.id;if(-1===e){if(-1===(d.id=c.rootSegmentID))throw Error("A root segment ID must have been assigned by now. This is a bug in React.");return Se(a,b,d)}if(e===c.rootSegmentID)return Se(a,b,d);Se(a,b,d);c=a.resumableState;a=a.renderState;(d=0===c.streamingFormat)?(b.push(a.startInlineScript),0===(c.instructions&1)?(c.instructions|=1,b.push('$RS=function(a,b){a=document.getElementById(a);b=document.getElementById(b);for(a.parentNode.removeChild(a);a.firstChild;)b.parentNode.insertBefore(a.firstChild,b);b.parentNode.removeChild(b)};$RS("')):
b.push('$RS("')):b.push('<template data-rsi="" data-sid="');b.push(a.segmentPrefix);e=e.toString(16);b.push(e);d?b.push('","'):b.push('" data-pid="');b.push(a.placeholderPrefix);b.push(e);b=d?b.push('")\x3c/script>'):b.push('"></template>');return b}
function Pe(a,b){try{var c,d=a.completedRootSegment;if(null!==d)if(0===a.pendingRootTasks){var e=a.renderState;if((0!==a.allPendingTasks||null!==a.trackedPostpones)&&e.externalRuntimeScript){var f=e.externalRuntimeScript,g=a.resumableState,h=f.src,k=f.chunks;g.scriptResources.hasOwnProperty(h)||(g.scriptResources[h]=null,e.scripts.add(k))}var l=e.htmlChunks,n=e.headChunks;f=0;if(l){for(f=0;f<l.length;f++)b.push(l[f]);if(n)for(f=0;f<n.length;f++)b.push(n[f]);else{var q=I("head");b.push(q);b.push(">")}}else if(n)for(f=
0;f<n.length;f++)b.push(n[f]);var m=e.charsetChunks;for(f=0;f<m.length;f++)b.push(m[f]);m.length=0;e.preconnects.forEach(J,b);e.preconnects.clear();var y=e.preconnectChunks;for(f=0;f<y.length;f++)b.push(y[f]);y.length=0;e.fontPreloads.forEach(J,b);e.fontPreloads.clear();e.highImagePreloads.forEach(J,b);e.highImagePreloads.clear();e.styles.forEach(kc,b);var A=e.importMapChunks;for(f=0;f<A.length;f++)b.push(A[f]);A.length=0;e.bootstrapScripts.forEach(J,b);e.scripts.forEach(J,b);e.scripts.clear();e.bulkPreloads.forEach(J,
b);e.bulkPreloads.clear();var Q=e.preloadChunks;for(f=0;f<Q.length;f++)b.push(Q[f]);Q.length=0;var M=e.hoistableChunks;for(f=0;f<M.length;f++)b.push(M[f]);M.length=0;l&&null===n&&(b.push("</"),b.push("head"),b.push(">"));Re(a,b,d);a.completedRootSegment=null;Pb(b,a.renderState)}else return;var p=a.renderState;d=0;p.preconnects.forEach(J,b);p.preconnects.clear();var t=p.preconnectChunks;for(d=0;d<t.length;d++)b.push(t[d]);t.length=0;p.fontPreloads.forEach(J,b);p.fontPreloads.clear();p.highImagePreloads.forEach(J,
b);p.highImagePreloads.clear();p.styles.forEach(mc,b);p.scripts.forEach(J,b);p.scripts.clear();p.bulkPreloads.forEach(J,b);p.bulkPreloads.clear();var Z=p.preloadChunks;for(d=0;d<Z.length;d++)b.push(Z[d]);Z.length=0;var F=p.hoistableChunks;for(d=0;d<F.length;d++)b.push(F[d]);F.length=0;var N=a.clientRenderedBoundaries;for(c=0;c<N.length;c++){var u=N[c];p=b;var z=a.resumableState,U=a.renderState,P=u.rootSegmentID,da=u.errorDigest,G=u.errorMessage,ea=u.errorComponentStack,aa=0===z.streamingFormat;aa?
(p.push(U.startInlineScript),0===(z.instructions&4)?(z.instructions|=4,p.push('$RX=function(b,c,d,e){var a=document.getElementById(b);a&&(b=a.previousSibling,b.data="$!",a=a.dataset,c&&(a.dgst=c),d&&(a.msg=d),e&&(a.stck=e),b._reactRetry&&b._reactRetry())};;$RX("')):p.push('$RX("')):p.push('<template data-rxi="" data-bid="');p.push(U.boundaryPrefix);var Ma=P.toString(16);p.push(Ma);aa&&p.push('"');if(da||G||ea)if(aa){p.push(",");var Na=ac(da||"");p.push(Na)}else{p.push('" data-dgst="');var Oa=w(da||
"");p.push(Oa)}if(G||ea)if(aa){p.push(",");var Pa=ac(G||"");p.push(Pa)}else{p.push('" data-msg="');var ma=w(G||"");p.push(ma)}if(ea)if(aa){p.push(",");var O=ac(ea);p.push(O)}else{p.push('" data-stck="');var ob=w(ea);p.push(ob)}if(aa?!p.push(")\x3c/script>"):!p.push('"></template>')){a.destination=null;c++;N.splice(0,c);return}}N.splice(0,c);var V=a.completedBoundaries;for(c=0;c<V.length;c++)if(!Te(a,b,V[c])){a.destination=null;c++;V.splice(0,c);return}V.splice(0,c);var na=a.partialBoundaries;for(c=
0;c<na.length;c++){var oa=na[c];a:{N=a;u=b;N.renderState.boundaryResources=oa.resources;var pa=oa.completedSegments;for(z=0;z<pa.length;z++)if(!Ue(N,u,oa,pa[z])){z++;pa.splice(0,z);var Qa=!1;break a}pa.splice(0,z);Qa=hc(u,oa.resources,N.renderState)}if(!Qa){a.destination=null;c++;na.splice(0,c);return}}na.splice(0,c);var qa=a.completedBoundaries;for(c=0;c<qa.length;c++)if(!Te(a,b,qa[c])){a.destination=null;c++;qa.splice(0,c);return}qa.splice(0,c)}finally{0===a.allPendingTasks&&0===a.pingedTasks.length&&
0===a.clientRenderedBoundaries.length&&0===a.completedBoundaries.length&&(a.flushScheduled=!1,null===a.trackedPostpones&&(c=a.resumableState,c.hasBody&&(b.push("</"),b.push("body"),b.push(">")),c.hasHtml&&(b.push("</"),b.push("html"),b.push(">"))),b.push(null),a.destination=null)}}function pc(a){if(!1===a.flushScheduled&&0===a.pingedTasks.length&&null!==a.destination){a.flushScheduled=!0;var b=a.destination;b?Pe(a,b):a.flushScheduled=!1}}
function Ve(a,b){if(1===a.status)a.status=2,b.destroy(a.fatalError);else if(2!==a.status&&null===a.destination){a.destination=b;try{Pe(a,b)}catch(c){W(a,c),Ae(a,c)}}}function We(a,b){try{var c=a.abortableTasks;if(0<c.size){var d=void 0===b?Error("The render was aborted by the server without a reason."):b;c.forEach(function(e){return Oe(e,a,d)});c.clear()}null!==a.destination&&Pe(a,a.destination)}catch(e){W(a,e),Ae(a,e)}}
function Ke(a,b,c){if(null===b)c.rootNodes.push(a);else{var d=c.workingMap,e=d.get(b);void 0===e&&(e=[b[1],b[2],[],null],d.set(b,e),Ke(e,b[0],c));e[2].push(a)}}function Xe(){}
function Ye(a,b,c,d){var e=!1,f=null,g="",h=!1;b=lb(b?b.identifierPrefix:void 0,void 0);a=te(a,b,sc(b,c),mb(),Infinity,Xe,void 0,function(){h=!0},void 0,void 0,void 0);a.flushScheduled=null!==a.destination;xe(a);We(a,d);Ve(a,{push:function(k){null!==k&&(g+=k);return!0},destroy:function(k){e=!0;f=k}});if(e&&f!==d)throw f;if(!h)throw Error("A component suspended while responding to synchronous input. This will cause the UI to be replaced with a loading indicator. To fix, updates that suspend should be wrapped with startTransition.");return g}
function Ze(a,b){a.prototype=Object.create(b.prototype);a.prototype.constructor=a;a.__proto__=b}var $e=function(a){function b(){var d=a.call(this,{})||this;d.request=null;d.startedFlowing=!1;return d}Ze(b,a);var c=b.prototype;c._destroy=function(d,e){We(this.request);e(d)};c._read=function(){this.startedFlowing&&Ve(this.request,this)};return b}(ja.Readable);function af(){}
function bf(a,b){var c=new $e;b=lb(b?b.identifierPrefix:void 0,void 0);var d=te(a,b,sc(b,!1),mb(),Infinity,af,function(){c.startedFlowing=!0;Ve(d,c)},void 0,void 0,void 0);c.request=d;d.flushScheduled=null!==d.destination;xe(d);return c}exports.renderToNodeStream=function(a,b){return bf(a,b)};exports.renderToStaticMarkup=function(a,b){return Ye(a,b,!0,'The server used "renderToStaticMarkup" which does not support Suspense. If you intended to have the server wait for the suspended component please switch to "renderToPipeableStream" which supports Suspense on the server')};
exports.renderToStaticNodeStream=function(a,b){return bf(a,b)};exports.renderToString=function(a,b){return Ye(a,b,!1,'The server used "renderToString" which does not support Suspense. If you intended for this Suspense boundary to render the fallback content on the server consider throwing an Error somewhere within the Suspense boundary. If you intended to have the server wait for the suspended component please switch to "renderToPipeableStream" which supports Suspense on the server')};
exports.version="18.3.0-experimental-d803f519e-20231020";
